{$ASMMODE INTEL}
{$APPTYPE GUI}
{$MODE FPC}
{$RANGECHECKS OFF}
{$Q-}
{$S-}
{$D-}


//////////////////////////////////////////////////
// Copyright (c) 2002 by venom, VENOM Software. //
// All rights reserved.                         //
// Visit me at http://www.venomsoftware.de      //
//////////////////////////////////////////////////




UNIT VGFX;


INTERFACE




USES     Windows,Sysutils,MMX;




PROCEDURE GetDefaultDirectDraw(ParentWindow : hWND; x,y,bits : longint);stdcall; // Using the FPCX functions to enter a direct draw graphic mode
 external 'fpcx' name 'GetDefaultDirectDraw';                               // The FPCX was made by the Toxic Avenger /AINC
PROCEDURE CloseDirectDraw;stdcall;
 external 'fpcx' name 'CloseDirectDraw';
FUNCTION DirectDrawBlit(buf : pointer) : boolean;stdcall;
 external 'fpcx' name 'DirectDrawBlit';




CONST    VGFX_Version               = 2.0;

         TotalAllocMemory           : LongInt =    0;
         VGFXGraphLoaded            : Boolean = False;
         ApplicationRunning         : Boolean = False;
         Maximiert                  : Boolean = True;
         Cursor                     : Boolean = True;
         Window_Main_Handle         : HWnd    = 0;
         WindowClass                : PChar   = 'VGFX window';




                                        // Structure for virtual windows
TYPE     VirtualWindow = Record
                          VWOffset       : Longint;
                          Size           : Longint;
                          Breite         : Longint;
                          BreiteMinus1   : Longint;
                          BreiteDiv2     : Longint;
                          BreiteMod2     : Longint;
                          ByteBreite     : Longint;
                          Hoehe          : Longint;
                          HoeheDiv2      : Longint;
                          HoeheMinus1    : Longint;
                          Active         : Boolean;
                          OptionalPath   : String;
                         End;


VAR      DD_Breite       : Longint;  // Infos about the actual direct draw window
         DD_BreiteDiv2   : Longint;
         DD_HoeheDiv2    : Longint;
         DD_BreiteDiv2M1 : Longint;
         DD_HoeheDiv2M1  : Longint;
         DD_BreiteMinus1 : Longint;
         DD_HoeheMinus1  : Longint;
         DD_Hoehe        : Longint;
         DD_HoeheDiv2M1M : Longint;
         DD_BreiteDiv2M1M: Longint;
         DD_BreiteDiv2Min: Longint;
         DD_HoeheDiv2Min : Longint;
         DD_Size         : Longint;
         MyDeviceMode    : DevMode;
         DeviceModeOk    : Boolean;
         Sinus,CoSin     : Array[0..360] of Single;
         Placement       : WindowPlacement;
         AfterPOSTProc   : PROCEDURE;




{----------------------------- DIVERSES -------------------------------------}

 PROCEDURE CursorVisible(Status:Boolean);

 FUNCTION  PtrMem(Zeiger:Longint):Longint;

 PROCEDURE Maximize(Status:Boolean);

 PROCEDURE ERRORM       (SourceText1,SourceText2:String);
 PROCEDURE Post         (SourceText1,SourceText2:String);
 FUNCTION  FileOverWrite(Datei:String):Boolean;

 PROCEDURE CheckMemory;

 PROCEDURE WaitMS(ms:Longint);

 // ATTENTION !  Set "AdressTraeger:= 0;" before first use
 PROCEDURE AllokSpeicher(var AdressTraeger:Longint;Groesse:Longint);
 PROCEDURE FreeSpeicher (var AdressTraeger:Longint);
 // ATTENTION !  Set "AdressTraeger:= Nil;" before first use
 PROCEDURE AllokPTRspeicher(var AdressTraeger:Pointer;Groesse:Longint);
 PROCEDURE FreePTRspeicher (var AdressTraeger:Pointer);

 FUNCTION  RealStr(RealZahl:Single;Vork,Nachk:Byte):String;
 FUNCTION  LongIntStr(LongIntZahl:LongInt):String;

 FUNCTION  DezToHex(Wert:LongInt):String;
 FUNCTION  DezToBin(Wert:   Word):String;

 FUNCTION  GetString(Adresse:Longint;Var Laenge:Word):String;

{----------------------------- GRAFIKROUTINEN -------------------------------}

 PROCEDURE Calculate_ScreenSettings(Width,Height:Longint);

 PROCEDURE SetResolution(Breite,Hoehe,Bpp:Dword);
 PROCEDURE ReSetResolution;

 PROCEDURE Init_Graph(Breite,Hoehe:Longint);
 PROCEDURE Kill_Graph;

 PROCEDURE CalculateVW(var VW:VirtualWindow;Breite,Hoehe:Longint);

 PROCEDURE Init_VW(var VWPage:VirtualWindow;Breite,Hoehe:Longint;Clear:Boolean);
 PROCEDURE Kill_VW(var VWPage:VirtualWindow);

 PROCEDURE Flip_DD(Source:Longint);
 PROCEDURE Flip_VW(Source,Dest:Longint);

 PROCEDURE Clr_VW(Dest:Longint;Color:Word);
 PROCEDURE Clr_DD(Color:Word);

 PROCEDURE ClrSprite      (Sprite:VirtualWindow;r,g,b:Word);
 PROCEDURE ClrPackedSprite(Sprite:VirtualWindow;Color:Word);

{---------------------------------------------------------------------------}




IMPLEMENTATION



CONST  Copyright = 'Copyright (c) 2002 by venom, VENOM Software. All rights reserved.';


VAR    TempVar1            : Word;
       TempVar2            : Real;
       Loop1,Loop2,Loop3   : Longint;
       Kette,Kette2        : String;
       ClearVW             : VirtualWindow;




{----------------------------- DIVERSES -------------------------------------}


PROCEDURE CursorVisible(Status:Boolean);
Begin
 If Status then
 begin
  If Cursor then ShowCursor(False);
  ShowCursor(True);
  Cursor:= True;
 end
 else
 begin
  If not Cursor then ShowCursor(True);
  ShowCursor(False);
  Cursor:= False;
 end;
End;


FUNCTION PtrMem(Zeiger:Longint):Longint;
VAR      MemSize : Longint;
Begin
 If Zeiger<>0 then
 Asm
  Mov esi,Zeiger
  Mov eax,[esi-4]
  Mov MemSize,eax
 End else MemSize:= 0;
 PtrMem:= MemSize;
End;


PROCEDURE Maximize(Status:Boolean);
VAR       UpperLeft : POINT;
          Rectangle : RECT;
Begin
 Placement.Length          := Sizeof(WindowPlacement);
 Placement.flags           := 0;
 UpperLeft.x:= 0;
 UpperLeft.y:= 0;
 Placement.ptMinPosition   := UpperLeft;
 Placement.ptMaxPosition   := UpperLeft;
 Rectangle.left  := 0;
 Rectangle.top   := 0;
 Rectangle.right := DD_BreiteMinus1;
 Rectangle.bottom:= DD_HoeheMinus1;
 Placement.rcNormalPosition:= Rectangle;
 If not Status
 then Placement.showcmd    := SW_Minimize
 else Placement.showcmd    := SW_Restore;

 SetWindowPlacement(Window_Main_Handle,Placement);
 Maximiert:= Status;
End;


PROCEDURE ERRORM(SourceText1,SourceText2:String);
VAR       TempPChar1,TempPChar2 : PChar;
Begin
 TempPChar1:= StrAlloc(Length(SourceText1)+1);
 StrPCopy(TempPChar1,SourceText1);
 TempPChar2:= StrAlloc(Length(SourceText2)+1);
 StrPCopy(TempPChar2,SourceText2);

 CursorVisible(True);

 IF VGFXGraphLoaded then begin Maximize(False); AfterPOSTproc(); end;

 MessageBox(Window_Main_Handle,TempPChar2,TempPChar1,MB_ok or MB_IconStop or MB_SetForeGround or MB_TopMost);

 IF VGFXGraphLoaded then begin Maximize(True ); AfterPOSTproc(); end;

 StrDispose(TempPChar1);
 StrDispose(TempPChar2);

 Kill_Graph;
 halt;
End;


PROCEDURE Post(SourceText1,SourceText2:String);
VAR       TempPChar1,TempPChar2 : PChar;
          OldCursorStatus       : Boolean;
Begin
 TempPChar1:= StrAlloc(Length(SourceText1)+1);
 StrPCopy(TempPChar1,SourceText1);
 TempPChar2:= StrAlloc(Length(SourceText2)+1);
 StrPCopy(TempPChar2,SourceText2);

 OldCursorStatus:= Cursor;

 CursorVisible(True);

 If VGFXGraphLoaded then begin Maximize(False); AfterPOSTproc(); end;

 MessageBox(Window_Main_Handle,TempPChar2,TempPChar1,MB_ok or MB_IconInformation or MB_SetForeGround or MB_TopMost);

 If VGFXGraphLoaded then begin Maximize(True ); AfterPOSTproc(); end;

 CursorVisible(OldCursorStatus);

 StrDispose(TempPChar1);
 StrDispose(TempPChar2);
End;


FUNCTION  FileOverWrite(Datei:String):Boolean;
VAR       TempPChar1      : PChar;
          OldCursorStatus : Boolean;
Begin
 FileOverWrite:= True;
 If FileExists(Datei) then
 begin
  Kette:= '"'+Datei+'" already exists ! Overwrite ?';

  TempPChar1:= StrAlloc(Length(Kette)+1);
  StrPCopy(TempPChar1,Kette);

  OldCursorStatus:= Cursor;

  CursorVisible(True);

  If VGFXGraphLoaded then begin Maximize(False); AfterPOSTproc(); end;

  If MessageBox(0,TempPChar1,'MESSAGE',MB_YesNo or MB_IconQuestion or MB_SetForeGround or MB_TaskModal or MB_TopMost)
  = IDNo then FileOverWrite:= False;

  If VGFXGraphLoaded then begin Maximize(True ); AfterPOSTproc(); end;

  CursorVisible(OldCursorStatus);

  StrDispose(TempPChar1);
 end;
End;


PROCEDURE CheckMemory;
Begin
 If TotalAllocMemory>0 then
 POST('MEMORY MANAGEMENT ERROR !','There is still some allocated memory left !'+#13+#13+longintstr(TotalAllocMemory)+' BYTES   or   '+longintstr(Round(TotalAllocMemory / 1024))+' KB   or   '+longintstr(Round((TotalAllocMemory / 1024) / 1024))+' MB');
End;


PROCEDURE WaitMS(ms:Longint);
VAR       Oldticks : Longint;
Begin
 Oldticks:= Gettickcount;
 REPEAT UNTIL Gettickcount >= Oldticks +  ms;
End;


PROCEDURE AllokSpeicher(var AdressTraeger:Longint;Groesse:Longint);
VAR       TempZeiger : Pointer;
Begin
 If AdressTraeger=0 then
 begin
  Getmem(TempZeiger,Groesse);
  If TempZeiger = Nil then ERRORM('MEMORY ERROR !','Not enough memory to run this application !');
  AdressTraeger:= Longint(TempZeiger);
  TotalAllocMemory:= TotalAllocMemory + PtrMem(Adresstraeger);
 end
 else
 begin
  TotalAllocMemory:= TotalAllocMemory - PtrMem(Adresstraeger);
  TempZeiger:= Pointer(AdressTraeger);
  Reallocmem(TempZeiger,Groesse);
  If TempZeiger = Nil then ERRORM('MEMORY ERROR !','Not enough memory to run this application !');
  AdressTraeger:= Longint(TempZeiger);
  TotalAllocMemory:= TotalAllocMemory + PtrMem(Adresstraeger);
 end;
End;


PROCEDURE AllokPTRspeicher(var AdressTraeger:Pointer;Groesse:Longint);
Begin
 If AdressTraeger=Nil then
 begin
  Getmem(AdressTraeger,Groesse);
  If AdressTraeger = Nil then ERRORM('MEMORY ERROR !','Not enough memory to run this application !');
  TotalAllocMemory:= TotalAllocMemory + PtrMem(Longint(Adresstraeger));
 end
 else
 begin
  TotalAllocMemory:= TotalAllocMemory - PtrMem(Longint(Adresstraeger));
  Reallocmem(AdressTraeger,Groesse);
  If AdressTraeger = Nil then ERRORM('MEMORY ERROR !','Not enough memory to run this application !');
  TotalAllocMemory:= TotalAllocMemory + PtrMem(Longint(Adresstraeger));
 end;
End;


PROCEDURE FreePTRspeicher(var AdressTraeger:Pointer);
Begin
 If AdressTraeger<>Nil then
 begin
  TotalAllocMemory:= TotalAllocMemory - PtrMem(Longint(Adresstraeger));
  FreeMem(AdressTraeger);
  AdressTraeger:= Nil;
 end;
End;


PROCEDURE FreeSpeicher(var AdressTraeger:Longint);
VAR       TempZeiger : Pointer;
Begin
 TempZeiger:= Pointer(AdressTraeger);
 If TempZeiger<>Nil then
 begin
  TotalAllocMemory:= TotalAllocMemory - PtrMem(Adresstraeger);
  FreeMem(TempZeiger);
  AdressTraeger:= 0;
 end;
End;


FUNCTION RealStr(RealZahl:Single;Vork,Nachk:Byte):String;
Begin
 RealStr:= '';
 Str(RealZahl:Vork:Nachk,RealStr);
End;


FUNCTION LongIntStr(LongIntZahl:LongInt):String;
VAR      TString : String;
Begin
 Str(LongIntZahl,TString);
 LongIntStr:= TString;
End;


FUNCTION DezToHex(Wert:Longint):String;
VAR      Wert2 : Array[0..7] of Char;
Begin
 For Loop1:=0 to 7 do Wert2[Loop1]:='0';
 Loop1:=7;
 REPEAT
  Loop2:=Wert-(Wert shr 4)*16;
  If Loop2<10 then Wert2[Loop1]:=chr(48+Loop2) else
  If Loop2> 9 then Wert2[Loop1]:=chr(55+Loop2);
  Wert:=Wert shr 4;
  dec(Loop1);
 UNTIL Wert=0;
 DezToHex:='$'+Wert2;
End;


FUNCTION DezToBin(Wert:Word):String;
Begin
 Loop1:=Wert;
 Kette:='';
 REPEAT
  If Loop1 mod 2 = 0 then Kette:='0'+Kette else Kette:='1'+Kette;
  Loop1:=Loop1 shr 1;
 UNTIL Loop1=0;
 If length(Kette)<8 then for Loop1:=1 to (8-length(Kette)) do Kette:='0'+Kette;
 DezToBin:=Kette;
End;


FUNCTION GetString(Adresse:Longint;Var Laenge:Word):String;
VAR      StringBuffer : Array[1..256] of Char;
         Byt          : Char;
         StrLaenge    : Word;
Begin
 StrLaenge   :=  0;
 GetString:= '';
 REPEAT
  Asm
   Inc StrLaenge
   Mov esi,Adresse
   Mov al ,[esi]
   Mov Byt,al
   Inc Adresse
  End;
  StringBuffer[StrLaenge]:= Byt;
  If Byt<>#0 then GetString:= GetString + StringBuffer[StrLaenge];
 UNTIL (Byt=#0) or (StrLaenge=255);
 Laenge:= StrLaenge;
End;


{----------------------------- GRAFIKROUTINEN -------------------------------}


PROCEDURE Calculate_ScreenSettings(Width,Height:Longint);
Begin
 DD_Breite:= Width;
 DD_Hoehe := Height;

 DD_BreiteMinus1 := Width - 1;
 DD_HoeheMinus1  := Height  - 1;

 DD_BreiteDiv2   := Width shr 1;
 DD_HoeheDiv2    := Height  shr 1;

 DD_BreiteDiv2M1 := DD_BreiteDiv2 - 1;
 DD_HoeheDiv2M1  := DD_HoeheDiv2  - 1;

 DD_HoeheDiv2M1M := -(DD_HoeheDiv2  -1);
 DD_BreiteDiv2M1M:= -(DD_BreiteDiv2 -1);

 DD_HoeheDiv2Min := -DD_HoeheDiv2;
 DD_BreiteDiv2Min:= -DD_BreiteDiv2;

 DD_Size         := Width * Height shl 1;
End;



PROCEDURE SetResolution(Breite,Hoehe,Bpp:Dword);
VAR       Counter : Word;
Begin
 Counter:= -1;
 REPEAT
  Inc(Counter);
  DeviceModeOk:= EnumDisplaySettings(Nil,Counter,@MyDeviceMode);
 UNTIL not DeviceModeOk or (Counter>65534) or ((MyDeviceMode.dmpelswidth = Breite) and (MyDeviceMode.dmpelsheight = Hoehe) and (MyDeviceMode.dmBitsPerPel = Bpp));

 If DeviceModeOk Then ChangeDisplaySettings(@MyDeviceMode,0);
End;



PROCEDURE ResetResolution;
Begin
 If DeviceModeOk Then ChangeDisplaySettings(Nil,0);
End;



PROCEDURE Init_Graph(Breite,Hoehe:Longint);
Begin
 If not VGFXGraphLoaded then
 begin
  CursorVisible(False);

  WAITMS(100);

  // Don't use this, FPCX will do the resolution switches
  // in GetDefaultDirectDraw() and CloseDirectDraw()
  //SetResolution(Breite,Hoehe,16);

  WAITMS(200);

  Calculate_ScreenSettings(Breite,Hoehe);

  GetDefaultDirectDraw(Window_Main_Handle,Breite,Hoehe,16);

  WAITMS(200);

  CursorVisible(False);

  VGFXGraphLoaded:= True;

  Init_VW(ClearVW,DD_Breite,DD_Hoehe,True);
 end;
End;


PROCEDURE Kill_Graph;
Begin
 If VGFXGraphLoaded then
 begin
  Kill_VW(ClearVW);

  WAITMS(100);

  CloseDirectDraw;

  WAITMS(200);

  // Don't use this, FPCX will do the resolution switches
  // in GetDefaultDirectDraw() and CloseDirectDraw()
  //ReSetResolution;

  WAITMS(200);

  VGFXGraphLoaded:= False;

  CursorVisible(True);
 end;
End;



PROCEDURE CalculateVW(var VW:VirtualWindow;Breite,Hoehe:Longint);
Begin
 VW.Size        := Breite * Hoehe shl 1;
 VW.Breite      := Breite;
 VW.BreiteMinus1:= Breite-1;
 VW.BreiteDiv2  := Breite shr 1;
 VW.BreiteMod2  := Breite mod 2;
 VW.ByteBreite  := Breite shl 1;
 VW.Hoehe       := Hoehe;
 VW.HoeheMinus1 := Hoehe-1;
 VW.HoeheDiv2   := Hoehe shr 1;
End;



PROCEDURE Init_VW(var VWPage:VirtualWindow;Breite,Hoehe:Longint;Clear:Boolean);
Begin
 CalculateVW(VWPage,Breite,Hoehe);

 VWPage.VWOffset:= 0;
 AllokSpeicher(VWPage.VWOffset,VWPage.Size);

 VWPage.Active:= True;

 If Clear then ClrPackedSprite(VWPage,0);
End;


PROCEDURE Kill_VW(var VWPage:VirtualWindow);
Begin
 If VWPage.Active then
 begin
  FreeSpeicher(VWPage.VWOffset);
  VWPage.Active:= False;
 end;
End;


PROCEDURE Flip_DD(Source:Longint);
Begin
 DirectDrawBlit(Pointer(Source));
End;


PROCEDURE Flip_VW(Source,Dest:Longint); Assembler;
Asm
 Mov esi,Source
 Mov edi,Dest

 Mov ecx,DD_Size

  Shr ecx,8
  @SCHLEIFE:

   MovQ mm1,[esi    ];     MovQ [edi    ],mm1
   MovQ mm1,[esi+  8];     MovQ [edi+  8],mm1
   MovQ mm1,[esi+ 16];     MovQ [edi+ 16],mm1
   MovQ mm1,[esi+ 24];     MovQ [edi+ 24],mm1
   MovQ mm1,[esi+ 32];     MovQ [edi+ 32],mm1
   MovQ mm1,[esi+ 40];     MovQ [edi+ 40],mm1
   MovQ mm1,[esi+ 48];     MovQ [edi+ 48],mm1
   MovQ mm1,[esi+ 56];     MovQ [edi+ 56],mm1
   MovQ mm1,[esi+ 64];     MovQ [edi+ 64],mm1
   MovQ mm1,[esi+ 72];     MovQ [edi+ 72],mm1
   MovQ mm1,[esi+ 80];     MovQ [edi+ 80],mm1
   MovQ mm1,[esi+ 88];     MovQ [edi+ 88],mm1
   MovQ mm1,[esi+ 96];     MovQ [edi+ 96],mm1
   MovQ mm1,[esi+104];     MovQ [edi+104],mm1
   MovQ mm1,[esi+112];     MovQ [edi+112],mm1
   MovQ mm1,[esi+120];     MovQ [edi+120],mm1
   MovQ mm1,[esi+128];     MovQ [edi+128],mm1
   MovQ mm1,[esi+136];     MovQ [edi+136],mm1
   MovQ mm1,[esi+144];     MovQ [edi+144],mm1
   MovQ mm1,[esi+152];     MovQ [edi+152],mm1
   MovQ mm1,[esi+160];     MovQ [edi+160],mm1
   MovQ mm1,[esi+168];     MovQ [edi+168],mm1
   MovQ mm1,[esi+176];     MovQ [edi+176],mm1
   MovQ mm1,[esi+184];     MovQ [edi+184],mm1
   MovQ mm1,[esi+192];     MovQ [edi+192],mm1
   MovQ mm1,[esi+200];     MovQ [edi+200],mm1
   MovQ mm1,[esi+208];     MovQ [edi+208],mm1
   MovQ mm1,[esi+216];     MovQ [edi+216],mm1
   MovQ mm1,[esi+224];     MovQ [edi+224],mm1
   MovQ mm1,[esi+232];     MovQ [edi+232],mm1
   MovQ mm1,[esi+240];     MovQ [edi+240],mm1
   MovQ mm1,[esi+248];     MovQ [edi+248],mm1

   Add esi,256
   Add edi,256

  Dec ecx
  JNZ @SCHLEIFE
  Emms
End;


PROCEDURE Clr_VW(Dest:Longint;Color:Word); Assembler;
Asm
 Mov ax,Color
 Shl eax,16
 Mov ax,Color

 Mov edi,Dest
 Mov ecx,DD_Size

   MovD mm1,eax
   MovD mm2,eax
   Psllq mm1,32
   Paddusw mm1,mm2

   Shr ecx,8
   @SCHLEIFE:

    MovQ [edi    ],mm1
    MovQ [edi+  8],mm1
    MovQ [edi+ 16],mm1
    MovQ [edi+ 24],mm1
    MovQ [edi+ 32],mm1
    MovQ [edi+ 40],mm1
    MovQ [edi+ 48],mm1
    MovQ [edi+ 56],mm1
    MovQ [edi+ 64],mm1
    MovQ [edi+ 72],mm1
    MovQ [edi+ 80],mm1
    MovQ [edi+ 88],mm1
    MovQ [edi+ 96],mm1
    MovQ [edi+104],mm1
    MovQ [edi+112],mm1
    MovQ [edi+120],mm1
    MovQ [edi+128],mm1
    MovQ [edi+136],mm1
    MovQ [edi+144],mm1
    MovQ [edi+152],mm1
    MovQ [edi+160],mm1
    MovQ [edi+168],mm1
    MovQ [edi+176],mm1
    MovQ [edi+184],mm1
    MovQ [edi+192],mm1
    MovQ [edi+200],mm1
    MovQ [edi+208],mm1
    MovQ [edi+216],mm1
    MovQ [edi+224],mm1
    MovQ [edi+232],mm1
    MovQ [edi+240],mm1
    MovQ [edi+248],mm1

    Add edi,256

   Dec ecx
   JNZ @SCHLEIFE

  Emms
End;


PROCEDURE Clr_DD(Color:Word);
Begin
 Flip_DD(ClearVW.VWOffset);
End;


PROCEDURE ClrSprite(Sprite:VirtualWindow;r,g,b:Word); Assembler;
Asm
 Shl r,11
 Shl g,5
 Mov bx,r
 Add bx,g
 Add bx,b
 Mov ax,bx
 Shl ebx,16
 Mov bx,ax

 Mov edi,Sprite
 Mov eax,[edi+4]
 Mov edi,[edi  ]

  Mov ecx,8
  Xor edx,edx
  Div ecx
  Mov ecx,eax

  MovD mm1,ebx
  MovD mm2,ebx
  Psllq mm1,32
  Paddusw mm1,mm2

  @SCHLEIFE:

    MovQ [edi],mm1
    Add edi,8

  LOOP @SCHLEIFE
  Emms

  Mov ecx,edx
  Rep StosB
End;


PROCEDURE ClrPackedSprite(Sprite:VirtualWindow;Color:Word); Assembler;
Asm
 Mov edi,Sprite
 Mov eax,[edi+4]
 Mov edi,[edi  ]

  Mov ecx,8
  Xor edx,edx
  Div ecx
  Mov ecx,eax
  Mov ax,Color
  Shl eax,16
  Mov ax,Color

  MovD mm1,eax
  MovD mm2,eax
  Psllq mm1,32
  Paddusw mm1,mm2

  @SCHLEIFE:

    MovQ [edi],mm1
    Add edi,8

  LOOP @SCHLEIFE
  Emms

  Mov ecx,edx
  Rep StosB
End;



(******************************** INIT UNIT *********************************)


BEGIN
 AfterPOSTproc:= Nil;

 DeviceModeOk:= False;

 If not Is_MMX_cpu then ERRORM('HARDWARE ERROR !','Your CPU does not support the MMX technology !');

 TempVar2:= 0;
 For TempVar1:= 0 to 360 do
 begin
  Sinus[TempVar1]:= Sin(TempVar2);
  CoSin[TempVar1]:= Cos(TempVar2);
  TempVar2       := TempVar2 + (Pi / 180);
 end;

 ReturnNILifGrowHeapFails:= True;   // Important !!!

 CursorVisible(Cursor);
END.




