{$calling oldfpccall} // special fix for FPC 2.0
{$ASMMODE INTEL}
{$APPTYPE GUI}
{$MODE FPC}
{$RANGECHECKS OFF}
{$Q-}
{$S-}
{$D-}


//////////////////////////////////////////////////
// Copyright (c) 2002 by venom, VENOM Software. //
// All rights reserved.                         //
// Visit me at http://www.venomsoftware.de      //
//////////////////////////////////////////////////




UNIT VGFX_2D;


INTERFACE



USES  VGFX;


CONST   VGFX_2D_Version = 2.0;



{---------------------------------------------------------------------------}

 PROCEDURE PutPixel(Dest  :VirtualWindow;x,y:LongInt;    r,g,b:Word);
 PROCEDURE GetPixel(Source:VirtualWindow;x,y:LongInt;Var r,g,b:Byte);

 PROCEDURE PutPackedPixel(Dest  :VirtualWindow;x,y:LongInt;Color:Word);
 FUNCTION  GetPackedPixel(Source:VirtualWindow;x,y:LongInt):Word;

 PROCEDURE PutClippedPixel(Dest  :VirtualWindow;x,y:LongInt;    r,g,b:Word);
 PROCEDURE GetClippedPixel(Source:VirtualWindow;x,y:LongInt;Var r,g,b:Byte);

 PROCEDURE PutPackedClippedPixel(Dest  :VirtualWindow;x,y:LongInt;Color:Word);
 FUNCTION  GetPackedClippedPixel(Source:VirtualWindow;x,y:LongInt):Word;
 PROCEDURE PutPackedClippedPixelVW(Dest,x,y:LongInt;Color:Word);

 PROCEDURE Line         (Dest:VirtualWindow;x1,y1,x2,y2:LongInt;r,g,b:Word);
 PROCEDURE LineSmoother (Dest:VirtualWindow;x1,y1,x2,y2:LongInt;r,g,b:Word);
 PROCEDURE LineClipped  (Dest:VirtualWindow;x1,y1,x2,y2:LongInt;Farbe:Word);
 PROCEDURE LineHorz     (Dest:VirtualWindow;x1,x2,y :LongInt;   Color:Word);
 PROCEDURE LineVert     (Dest:VirtualWindow;x1,y1,y2:LongInt;   Color:Word);
 PROCEDURE LineClippedVW(Dest,x1,y1,x2,y2:LongInt;Farbe:Word);

 PROCEDURE Rectangle(Dest:VirtualWindow;x1,y1,x2,y2:LongInt;r,g,b:Word);

 PROCEDURE     Circle(Dest:VirtualWindow;x0,y0,Radius:LongInt;r,g,b:Word);
 PROCEDURE FullCircle(Dest:VirtualWindow;x0,y0,Radius:LongInt;Color: Word);
 PROCEDURE FineCircle(Dest:VirtualWindow;x1,y1,Radius:Integer;r,g,b:Word;Detail:Real);

 PROCEDURE Alpha(dest,X,Y : Longint; r,g,b : shortint);
 PROCEDURE AlphaLight(Dest:VirtualWindow;X,Y : Longint; r,g,b : Word);
 PROCEDURE AlphaLightClipped(Dest:VirtualWindow;X,Y : Longint; r,g,b : Word);
 PROCEDURE AlphaLightClippedPacked(Dest:VirtualWindow;X,Y : Longint; Color : Word);
 PROCEDURE AlphaLightLine(Dest:VirtualWindow;x1,y1,x2,y2:LongInt;r,g,b:Word);
 PROCEDURE AlphaLightHORZLine(Dest:VirtualWindow;X,Y,X2 : Longint; r,g,b : Word);

{---------------------------------------------------------------------------}





IMPLEMENTATION


CONST   Copyright           = 'Copyright (c) 2002 by venom, VENOM Software. All rights reserved.';

VAR     Loop1   : LongInt;




{---------------------------------------------------------------------------}


PROCEDURE PutPixel(Dest:VirtualWindow;x,y:LongInt;r,g,b:Word); Assembler;
Asm
 Mov esi,Dest
 Mov eax,[esi+8]
 Mul y
 Add eax,x
 Shl eax,1
 Mov edi,[esi]
 Add edi,eax
 Shl r,11
 Shl g,5
 Mov ax,r
 Add ax,g
 Add ax,b
 Mov ds:[edi],ax
End;


PROCEDURE GetPixel(Source:VirtualWindow;x,y:LongInt;Var r,g,b:Byte);
VAR       red,green,blue : Byte;
          t1,t2 : LongInt;
Begin
 t1:= Source.Breite;
 t2:= Source.VWOffset;
 Asm
  Mov eax,t1
  Mul y
  Add eax,x
  Shl eax,1
  Add eax,t2
  Mov esi,eax
  Mov ax,[esi]

  Mov bl,al
  Shr ax,3
  Mov red,ah
  Shr al,2
  Mov green,al
  And bl,00011111b
  Mov blue,bl
 End;
 r:= red;
 g:= green;
 b:= blue;
End;



PROCEDURE PutClippedPixel(Dest:VirtualWindow;x,y:LongInt;r,g,b:Word); Assembler;
Asm
 Mov esi,Dest

 Mov eax,[esi+12]
 Cmp x,eax
 Ja @Ende
 Mov eax,[esi+36]
 Cmp y,eax
 Ja @Ende

 Mov eax,[esi+8]
 Mul y
 Add eax,x
 Shl eax,1
 Mov edi,[esi]
 Add edi,eax
 Shl g,5
 Mov ax,r
 Shl ax,11
 Add ax,g
 Add ax,b
 Mov ds:[edi],ax

 @Ende:
End;


PROCEDURE GetClippedPixel(Source:VirtualWindow;x,y:LongInt;Var r,g,b:Byte);
VAR       red,green,blue : Byte;
          t1,t2,t3,t4 : LongInt;
Begin
 t1:= Source.BreiteMinus1;
 t2:= Source.HoeheMinus1;
 t3:= Source.Breite;
 t4:= Source.VWOffset;
 Asm
  Mov eax,t1
  Cmp x,eax
  Ja @Ende
  Mov eax,t2
  Cmp y,eax
  Ja @Ende

  Mov eax,t3
  Mul y
  Add eax,x
  Shl eax,1
  Mov edi,t4
  Add edi,eax
  Mov ax,ds:[edi]
  Mov bl,al
  Shr ax,3
  Mov red,ah
  Shr al,2
  Mov green,al
  And bl,00011111b
  Mov blue,bl

  @Ende:
 End;
 r:= red;
 g:= green;
 b:= blue;
End;


PROCEDURE PutPackedPixel(Dest:VirtualWindow;x,y:LongInt;Color:Word); Assembler;
Asm
 Mov esi,Dest
 Mov eax,[esi+8]
 Mul y
 Add eax,x
 Shl eax,1
 Mov edi,[esi]
 Add edi,eax
 Mov ax,Color
 Mov ds:[edi],ax
End;


FUNCTION GetPackedPixel(Source:VirtualWindow;x,y:LongInt):Word; Assembler;
Asm
 Mov esi,Source
 Mov eax,[esi+8]
 Mul y
 Add eax,x
 Shl eax,1
 Mov edi,[esi]
 Add edi,eax
 Mov ax,ds:[edi]
End;


PROCEDURE PutPackedClippedPixel(Dest:VirtualWindow;x,y:LongInt;Color:Word); Assembler;
Asm
 Mov esi,Dest

 Mov eax,[esi+12]
 Cmp x,eax
 Ja @Ende
 Mov eax,[esi+36]
 Cmp y,eax
 Ja @Ende

 Mov eax,[esi+8]
 Mul y
 Add eax,x
 Shl eax,1
 Mov edi,[esi]
 Add edi,eax
 Mov ax,Color
 Mov ds:[edi],ax
 @Ende:
End;


PROCEDURE PutPackedClippedPixelVW(Dest,x,y:LongInt;Color:Word); Assembler;
Asm
 Mov eax,DD_BreiteMinus1
 Cmp x,eax
 Ja @Ende
 Mov eax,DD_HoeheMinus1
 Cmp y,eax
 Ja @Ende

 Mov eax,DD_Breite
 Mul y
 Add eax,x
 Shl eax,1
 Mov esi,Dest
 Add esi,eax
 Mov ax,Color
 Mov [esi],ax

 @Ende:
End;


FUNCTION GetPackedClippedPixel(Source:VirtualWindow;x,y:LongInt):Word; Assembler;
Asm
 Xor ax,ax
 Mov esi,Source

 Mov ebx,[esi+12]
 Cmp x,ebx
 Ja @Ende
 Mov ebx,[esi+36]
 Cmp y,ebx
 Ja @Ende

 Mov eax,[esi+8]
 Mul y
 Add eax,x
 Shl eax,1
 Mov edi,[esi]
 Add edi,eax
 Mov ax,ds:[edi]
 @Ende:
End;


PROCEDURE Rectangle(Dest:VirtualWindow;x1,y1,x2,y2:LongInt;r,g,b:Word);
Begin
 if x1<=x2 then for Loop1:= x1     to x2 do begin PutClippedPixel(Dest,Loop1,y1,r,g,b); PutClippedPixel(Dest,Loop1,y2,r,g,b); end
           else for Loop1:= x1 downto x2 do begin PutClippedPixel(Dest,Loop1,y1,r,g,b); PutClippedPixel(Dest,Loop1,y2,r,g,b); end;
 if y1<=y2 then for Loop1:= y1     to y2 do begin PutClippedPixel(Dest,x1,Loop1,r,g,b); PutClippedPixel(Dest,x2,Loop1,r,g,b); end
           else for Loop1:= y1 downto y2 do begin PutClippedPixel(Dest,x1,Loop1,r,g,b); PutClippedPixel(Dest,x2,Loop1,r,g,b); end;
End;


PROCEDURE Circle(Dest:VirtualWindow;x0,y0,Radius:LongInt;r,g,b: Word);
VAR x,y,p : longint;
Begin
 x:=0;
 y:=-radius;
 p:=y shl 1+3;
 While x<=-y do begin
  PutClippedPixel(Dest,x0+x,y0+y,r,g,b);
  PutClippedPixel(Dest,x0-x,y0+y,r,g,b);
  PutClippedPixel(Dest,x0+x,y0-y,r,g,b);
  PutClippedPixel(Dest,x0-x,y0-y,r,g,b);
  PutClippedPixel(Dest,x0+y,y0+x,r,g,b);
  PutClippedPixel(Dest,x0-y,y0+x,r,g,b);
  PutClippedPixel(Dest,x0+y,y0-x,r,g,b);
  PutClippedPixel(Dest,x0-y,y0-x,r,g,b);
  if p>=0 then
  begin
   inc(y);
   inc(p,(x+y) shl 2+6);
  end else inc(p,x shl 2+6);
  inc(x);
 End;
END;


PROCEDURE FullCircle(Dest:VirtualWindow;x0,y0,Radius:LongInt;Color: Word);
VAR x,y,p : longint;
Begin
 x:=0;
 y:=-radius;
 p:=y shl 1+3;
 While x<=-y do begin
  LineHorz (Dest,x0-x,x0+x,y0+y,Color);
  LineHorz (Dest,x0-x,x0+x,y0-y,Color);
  LineHorz (Dest,x0-y,x0+y,y0+x,Color);
  LineHorz (Dest,x0-y,x0+y,y0-x,Color);
  if p>=0 then
  begin
   inc(y);
   inc(p,(x+y) shl 2+6);
  end else inc(p,x shl 2+6);
  inc(x);
 End;
END;


PROCEDURE FineCircle(Dest:VirtualWindow;x1,y1,Radius:Integer;r,g,b:Word;Detail:Real);
VAR       x,y                 : Integer;
          xReal,QRadius       : Real;
Begin
 QRadius:=Radius*Radius;
 xReal  :=Radius;
 REPEAT
  y:= trunc(sqrt(QRadius-xReal*xReal));
  x:= trunc(xReal);
  PutClippedPixel(Dest,x1+x,y1-y,r,g,b);
  PutClippedPixel(Dest,x1+x,y1+y,r,g,b);
  PutClippedPixel(Dest,x1-x,y1-y,r,g,b);
  PutClippedPixel(Dest,x1-x,y1+y,r,g,b);
  xReal:=xReal-Detail;
 UNTIL xReal<=0.00;
End;


PROCEDURE LineHorz(Dest:VirtualWindow;x1,x2,y:LongInt;Color:Word); Assembler;
Asm
 Mov eax,x1
 Cmp x2,eax
 Jg @Jump1
  Mov ebx,x2
  Mov x2,eax
  Mov x1,ebx
 @Jump1:
 Je @Ende

   Mov esi,Dest
   Mov edi,[esi]
   Mov eax,[esi+8]
   Mul y
   Add eax,x1
   Shl eax,1
   Add edi,eax

   Xor edx,edx
   Mov eax,x2
   Sub eax,x1
   Inc eax
   Mov ebx,2
   Div ebx

   Mov ecx,eax
   Mov ax,Color
   Shl eax,16
   Mov ax,Color
   Rep StosD
   Mov ecx,edx
   Rep StosW

 @ENDE:
End;


PROCEDURE LineVert(Dest:VirtualWindow;x1,y1,y2:LongInt;Color:Word);
VAR       t,t1,t2 : LongInt;
Begin
  t1:= Dest.ByteBreite;
  t2:= Dest.VWOffset;
  if y2<y1 then begin t:=y1; y1:=y2; y2:=t; end;
  if y1=y2 then exit;
  asm
      mov eax, t1
      mul y1
      add eax, x1
      add eax, x1
      add eax, t2
      mov edi, eax

      mov ecx, y2
      sub ecx, y1
      Inc ecx

      mov ax, Color
    @HL:
      mov [edi], ax
      add edi,t1
    LOOP @HL
  end;
End;


PROCEDURE Line(Dest:VirtualWindow;x1,y1,x2,y2:LongInt;r,g,b:Word);
VAR       xDIFF,yDIFF,xADD,yADD,Rest : LongInt;
Begin
 ASM
  Mov eax,x1
  Cmp eax,x2
  Jl  @Kleiner1
   Je @Ende1
   Mov xAdd,-1
   Jmp @Ende1
  @Kleiner1:
  Mov xAdd,1
  @Ende1:

  Mov eax,y1
  Cmp eax,y2
  Jl  @Kleiner2
   Je @Ende2
   Mov yAdd,-1
   Jmp @Ende2
  @Kleiner2:
  Mov yAdd,1
  @Ende2:
 END;
 xDIFF:=abs(x1-x2);
 yDIFF:=abs(y1-y2);
 PutPixel(Dest,x1,y1,r,g,b);
 If xDIFF>yDIFF then
 begin
  Rest:=-(xDIFF shr 1);
  WHILE x1<>x2 do
  begin
   Inc(Rest,yDIFF);
   Inc(x1,xADD);
   If Rest>0 then
   begin
    Inc(y1,yADD);
    Dec(Rest,xDIFF);
   end;
   PutPixel(Dest,x1,y1,r,g,b);
  end;
 end
 else
 begin
  Rest:=-(yDIFF shr 1);
  WHILE y1<>y2 do
  begin
   Inc(Rest,xDIFF);
   Inc(y1,yADD);
   If Rest>0 then
   begin
    Inc(x1,xADD);
    Dec(Rest,yDIFF);
   end;
   PutPixel(Dest,x1,y1,r,g,b);
  end;
 end;
End;



PROCEDURE LineSmoother(Dest:VirtualWindow;x1,y1,x2,y2:LongInt;r,g,b:Word);
VAR       xDIFF,yDIFF,xADD,yADD,Rest : LongInt;
Begin
 ASM
  Mov eax,x1
  Cmp eax,x2
  Jl  @Kleiner1
   Je @Ende1
   Mov xAdd,-1
   Jmp @Ende1
  @Kleiner1:
  Mov xAdd,1
  @Ende1:

  Mov eax,y1
  Cmp eax,y2
  Jl  @Kleiner2
   Je @Ende2
   Mov yAdd,-1
   Jmp @Ende2
  @Kleiner2:
  Mov yAdd,1
  @Ende2:
 END;
 xDIFF:=abs(x1-x2);
 yDIFF:=abs(y1-y2);
 PutPixel(Dest,x1,y1,r,g,b);
 If xDIFF>yDIFF then
 begin
  Rest:=-(xDIFF shr 1);
  WHILE x1<>x2 do
  begin
   Inc(Rest,yDIFF);
   Inc(x1,xADD);
   PutPixel(Dest,x1,y1,r,g,b);
   If Rest>0 then
   begin
    Inc(y1,yADD);
    Dec(Rest,xDIFF);
   end;
   PutPixel(Dest,x1,y1,r,g,b);
  end;
 end
 else
 begin
  Rest:=-(yDIFF shr 1);
  WHILE y1<>y2 do
  begin
   Inc(Rest,xDIFF);
   Inc(y1,yADD);
   PutPixel(Dest,x1,y1,r,g,b);
   If Rest>0 then
   begin
    Inc(x1,xADD);
    Dec(Rest,yDIFF);
   end;
   PutPixel(Dest,x1,y1,r,g,b);
  end;
 end;
End;



PROCEDURE LineClipped(Dest:VirtualWindow;x1,y1,x2,y2:LongInt;Farbe:Word);
VAR       xDIFF,yDIFF,xADD,yADD,Rest : LongInt;
Begin
 ASM
  Mov eax,x1
  Cmp eax,x2
  Jl  @Kleiner1
   Je @Ende1
   Mov xAdd,-1
   Jmp @Ende1
  @Kleiner1:
  Mov xAdd,1
  @Ende1:

  Mov eax,y1
  Cmp eax,y2
  Jl  @Kleiner2
   Je @Ende2
   Mov yAdd,-1
   Jmp @Ende2
  @Kleiner2:
  Mov yAdd,1
  @Ende2:
 END;
 xDIFF:=abs(x1-x2);
 yDIFF:=abs(y1-y2);
 PutPackedClippedPixel(Dest,x1,y1,Farbe);
 If xDIFF>yDIFF then
 begin
  Rest:=-(xDIFF shr 1);
  WHILE x1<>x2 do
  begin
   Inc(Rest,yDIFF);
   Inc(x1,xADD);
   If Rest>0 then
   begin
    Inc(y1,yADD);
    Dec(Rest,xDIFF);
   end;
   PutPackedClippedPixel(Dest,x1,y1,Farbe);
  end;
 end
 else
 begin
  Rest:=-(yDIFF shr 1);
  WHILE y1<>y2 do
  begin
   Inc(Rest,xDIFF);
   Inc(y1,yADD);
   If Rest>0 then
   begin
    Inc(x1,xADD);
    Dec(Rest,yDIFF);
   end;
   PutPackedClippedPixel(Dest,x1,y1,Farbe);
  end;
 end;
End;


PROCEDURE LineClippedVW(Dest,x1,y1,x2,y2:LongInt;Farbe:Word);
VAR       xDIFF,yDIFF,xADD,yADD,Rest : LongInt;
Begin
 ASM
  Mov eax,x1
  Cmp eax,x2
  Jl  @Kleiner1
   Je @Ende1
   Mov xAdd,-1
   Jmp @Ende1
  @Kleiner1:
  Mov xAdd,1
  @Ende1:

  Mov eax,y1
  Cmp eax,y2
  Jl  @Kleiner2
   Je @Ende2
   Mov yAdd,-1
   Jmp @Ende2
  @Kleiner2:
  Mov yAdd,1
  @Ende2:
 END;
 xDIFF:=abs(x1-x2);
 yDIFF:=abs(y1-y2);
 PutPackedClippedPixelVW(Dest,x1,y1,Farbe);
 If xDIFF>yDIFF then
 begin
  Rest:=-(xDIFF shr 1);
  WHILE x1<>x2 do
  begin
   Inc(Rest,yDIFF);
   Inc(x1,xADD);
   If Rest>0 then
   begin
    Inc(y1,yADD);
    Dec(Rest,xDIFF);
   end;
   PutPackedClippedPixelVW(Dest,x1,y1,Farbe);
  end;
 end
 else
 begin
  Rest:=-(yDIFF shr 1);
  WHILE y1<>y2 do
  begin
   Inc(Rest,xDIFF);
   Inc(y1,yADD);
   If Rest>0 then
   begin
    Inc(x1,xADD);
    Dec(Rest,yDIFF);
   end;
   PutPackedClippedPixelVW(Dest,x1,y1,Farbe);
  end;
 end;
End;


PROCEDURE Alpha(dest,X,Y : Longint; r,g,b : shortint); Assembler;
ASM
  mov eax, Y
  imul eax, DD_Breite
  add eax, x
  shl eax, 1
  mov edi, eax
  add edi, dest
  Mov ax,[edi]

  mov bh, ah
  shr bh, 3 {bh = rot}
  add bh, r
  cmp bh, 0
  jge @@weiter1  {grer als 0 ?}
  xor bh,bh      {n ! auf 0 setzen}
 @@weiter1:
  cmp bh, 31
  jle @@weiter11 {kleiner als 31 ?}
  mov bh, 31     {n ! auf 31 setzen}
 @@weiter11:
  shl bh, 3

  mov bl, al
  and bl, 31 {bl = blau}
  add bl, b
  cmp bl, 0
  jge @@weiter2
  xor bl,bl
 @@weiter2:
  cmp bl, 31
  jle @@weiter21
  mov bl, 31
 @@weiter21:

  shr ax, 5
  and ax, 63 {ax = grn}
  add ax, g
  cmp ax, 0
  jge @@weiter3
  xor ax,ax
 @@weiter3:
  cmp ax, 63
  jle @@weiter31
  mov ax, 63
 @@weiter31:
  shl ax, 5

  Add al,bl
  Add ah,bh
  Mov [edi],ax
End;


PROCEDURE AlphaLight(Dest:VirtualWindow;X,Y : Longint; r,g,b : Word); Assembler;
Asm
  Mov edi,dest
  Mov eax,ds:[edi+8]
  Mul Y
  add eax, x
  shl eax, 1
  Mov edi,ds:[edi]
  Add edi, eax
  mov ax,[edi]
  mov bh, ah
  shr bh, 3 {bh = rot}
  add bh, r
  cmp bh, 31
  jle @@weiter11
  mov bh, 31
 @@weiter11:
  shl bh, 3

  mov bl, al
  and bl, 31 {bl = blau}
  add bl, b
  cmp bl, 31
  jle @@weiter21
  mov bl, 31
 @@weiter21:

  shr ax, 5
  and ax, 63 {ax = grn}
  add ax, g
 @@weiter3:
  cmp ax, 63
  jle @@weiter31
  mov ax, 63
 @@weiter31:
  shl ax, 5

  add al,bl
  add ah,bh
  mov [edi], ax
End;



PROCEDURE AlphaLightClipped(Dest:VirtualWindow;X,Y : Longint; r,g,b : Word); Assembler;
Asm
  Mov edi,Dest
  Mov eax,ds:[edi+12]
  Cmp x,eax
  Ja @Ende
  Mov eax,ds:[edi+36]
  Cmp y,eax
  Ja @Ende

  Mov eax,ds:[edi+8]
  Mul Y
  add eax, x
  shl eax, 1
  Mov edi,ds:[edi]
  Add edi, eax
  mov ax,[edi]
  mov bh, ah
  shr bh, 3 {bh = rot}
  add bh, r
  cmp bh, 31
  jle @@weiter11
  mov bh, 31
 @@weiter11:
  shl bh, 3

  mov bl, al
  and bl, 31 {bl = blau}
  add bl, b
  cmp bl, 31
  jle @@weiter21
  mov bl, 31
 @@weiter21:

  shr ax, 5
  and ax, 63 {ax = grn}
  add ax, g
 @@weiter3:
  cmp ax, 63
  jle @@weiter31
  mov ax, 63
 @@weiter31:
  shl ax, 5

  add al,bl
  add ah,bh
  mov [edi], ax
  @Ende:
End;


PROCEDURE AlphaLightClippedPacked(Dest:VirtualWindow;X,Y : Longint; Color : Word); Assembler;
VAR       r,g,b : Byte;
Asm
  Mov ax,Color
  Mov dl,al
  Shr ax,3
  Shr al,2
  Mov r,ah
  Mov g,al
  And dl,00011111b
  Mov b,dl

  Mov edi,Dest
  Mov eax,ds:[edi+12]
  Cmp x,eax
  Ja @Ende
  Mov eax,ds:[edi+36]
  Cmp y,eax
  Ja @Ende

  Mov eax,ds:[edi+8]
  Mul Y
  add eax, x
  shl eax, 1
  Mov edi,ds:[edi]
  Add edi, eax
  mov ax,[edi]
  mov bh, ah
  shr bh, 3 {bh = rot}
  add bh, r
  cmp bh, 31
  jle @@weiter11
  mov bh, 31
 @@weiter11:
  shl bh, 3

  mov bl, al
  and bl, 31 {bl = blau}
  add bl, b
  cmp bl, 31
  jle @@weiter21
  mov bl, 31
 @@weiter21:

  shr ax, 5
  and ax, 63 {ax = grn}
  add ax, g
 @@weiter3:
  cmp ax, 63
  jle @@weiter31
  mov ax, 63
 @@weiter31:
  shl ax, 5

  add al,bl
  add ah,bh
  mov [edi], ax
  @Ende:
End;


PROCEDURE AlphaLightLine(Dest:VirtualWindow;x1,y1,x2,y2:LongInt;r,g,b:Word);
VAR       xDIFF,yDIFF,xADD,yADD,Rest : LongInt;
Begin
 ASM
  Mov eax,x1
  Cmp eax,x2
  Jl  @Kleiner1
   Je @Ende1
   Mov xAdd,-1
   Jmp @Ende1
  @Kleiner1:
  Mov xAdd,1
  @Ende1:

  Mov eax,y1
  Cmp eax,y2
  Jl  @Kleiner2
   Je @Ende2
   Mov yAdd,-1
   Jmp @Ende2
  @Kleiner2:
  Mov yAdd,1
  @Ende2:
 END;
 xDIFF:=abs(x1-x2);
 yDIFF:=abs(y1-y2);
 AlphaLight(Dest,x1,y1,r,g,b);
 If xDIFF>yDIFF then
 begin
  Rest:=-(xDIFF shr 1);
  WHILE x1<>x2 do
  begin
   Inc(Rest,yDIFF);
   Inc(x1,xADD);
   If Rest>0 then
   begin
    Inc(y1,yADD);
    Dec(Rest,xDIFF);
   end;
   AlphaLight(Dest,x1,y1,r,g,b);
  end;
 end
 else
 begin
  Rest:=-(yDIFF shr 1);
  WHILE y1<>y2 do
  begin
   Inc(Rest,xDIFF);
   Inc(y1,yADD);
   If Rest>0 then
   begin
    Inc(x1,xADD);
    Dec(Rest,yDIFF);
   end;
   AlphaLight(Dest,x1,y1,r,g,b);
  end;
 end;
End;


PROCEDURE AlphaLightHORZLine(Dest:VirtualWindow;X,Y,X2 : Longint; r,g,b : Word); Assembler;
Asm
  Mov edi,dest
  Mov eax,ds:[edi+8]
  Mul Y
  add eax, x
  shl eax, 1
  Mov edi,ds:[edi]
  Add edi, eax
  Mov ecx,X2

  @LOOPALL:

  mov ax,[edi]
  mov bh, ah
  shr bh, 3 {bh = rot}
  add bh, r
  cmp bh, 31
  jle @@weiter11
  mov bh, 31
 @@weiter11:
  shl bh, 3

  mov bl, al
  and bl, 31 {bl = blau}
  add bl, b
  cmp bl, 31
  jle @@weiter21
  mov bl, 31
 @@weiter21:

  shr ax, 5
  and ax, 63 {ax = grn}
  add ax, g
 @@weiter3:
  cmp ax, 63
  jle @@weiter31
  mov ax, 63
 @@weiter31:
  shl ax, 5

  add al,bl
  add ah,bh
  mov [edi], ax
  Add edi,2
  LOOP @LOOPALL
End;



(******************************** INIT UNIT *********************************)


BEGIN

END.

