{$ASMMODE INTEL}
{$APPTYPE GUI}
{$MODE FPC}
{$RANGECHECKS OFF}
{$Q-}
{$S-}
{$D-}

//////////////////////////////////////////////////
// Copyright (c) 2002 by venom, VENOM Software. //
// All rights reserved.                         //
// Visit me at http://www.venomsoftware.de      //
//////////////////////////////////////////////////




UNIT VGFX_Sprites;


INTERFACE


USES     VGFX,
         VGFX_2D,
         VGFX_Errors,
         VGFX_Extra,
         VGFX_Files,
         Bigfile2,
         MMX;


CONST    VGFX_Sprites_Version = 2.0;


VAR      HWLPointer : Pointer;
         Memory     : Pointer;






{---------------------------------------------------------------------------}

 PROCEDURE Load_HWL   (Datei,BigDatei:String;Var Sprite:VirtualWindow);
 PROCEDURE Load_Sprite(Datei,BigDatei:String;Var Sprite:VirtualWindow);
 PROCEDURE Load_PCX   (Datei,BigDatei:String;Var Sprite:VirtualWindow);

 PROCEDURE Save_Sprite(Datei:String;var Sprite:VirtualWindow);

 PROCEDURE PutSprite(Dest,Sprite:VirtualWindow;x,y:LongInt);
 PROCEDURE GetSprite(Source:VirtualWindow;Sprite:VirtualWindow;x,y:LongInt);

 PROCEDURE PutClippedSprite(Dest,Sprite:VirtualWindow;x,y:LongInt);
 PROCEDURE GetClippedSprite(Source:VirtualWindow;Sprite:VirtualWindow;x,y:LongInt);

 PROCEDURE PutHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);
 PROCEDURE GetHCSprite(Source:VirtualWindow;Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);

 PROCEDURE PutClippedHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);
 PROCEDURE GetClippedHCSprite(Source:VirtualWindow;Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);


 { Following routines combines r,g,b of Dest/Sprite after they adjusted the Sprite r,g,b }

 PROCEDURE PutBrightSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rBright,gBright,bBright:ShortInt);

 PROCEDURE PutBrightClippedSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rBright,gBright,bBright:ShortInt);

 PROCEDURE PutBrightHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rBright,gBright,bBright:ShortInt;HideColor:Word);

 PROCEDURE PutBrightClippedHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rBright,gBright,bBright:ShortInt;HideColor:Word);


 { Following routines combines r,g,b of Dest/Sprite and div them by 2 }

 PROCEDURE PutMixedSprite(Dest,Sprite:VirtualWindow;x,y:LongInt);

 PROCEDURE PutMixedClippedSprite(Dest,Sprite:VirtualWindow;x,y:LongInt);

 PROCEDURE PutMixedHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);

 PROCEDURE PutMixedClippedHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);


 { Following routines combines r,g,b of Dest/Sprite after they adjusted the Dest r,g,b }

 PROCEDURE PutTransSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rLight,gLight,bLight:Byte);

 PROCEDURE PutTransClippedSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rLight,gLight,bLight:Byte);

 PROCEDURE PutTransHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rLight,gLight,bLight:Byte;HideColor:Word);

 PROCEDURE PutTransClippedHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rLight,gLight,bLight:Byte;HideColor:Word);


 { Following routines combines r,g,b of Dest/Sprite }

 PROCEDURE PutAlphaSprite(Dest,Sprite:VirtualWindow;x,y:LongInt);

 PROCEDURE PutAlphaClippedSprite(Dest,Sprite:VirtualWindow;x,y:LongInt);

 PROCEDURE PutAlphaHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);

 PROCEDURE PutAlphaClippedHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);


 PROCEDURE FadeSprite   (Source,Dest:VirtualWindow);
 PROCEDURE FadeSpriteVar(Source,Dest:VirtualWindow;r,g,b:Byte);

 PROCEDURE ScaleSprite(SourSprite,DestSprite:VirtualWindow);

 PROCEDURE AdjustSpriteBrightness    (SourSprite:VirtualWindow;r,g,b:ShortInt               );
 PROCEDURE AdjustSpriteHCBrightness  (SourSprite:VirtualWindow;r,g,b:ShortInt;HideColor:Word);

 PROCEDURE DecreaseSpriteBrightness  (SourSprite:VirtualWindow;r,g,b:Byte                   );
 PROCEDURE DecreaseSpriteHCBrightness(SourSprite:VirtualWindow;r,g,b:Byte;    HideColor:Word);

 PROCEDURE IncreaseSpriteBrightness  (SourSprite:VirtualWindow;r,g,b:Byte                   );
 PROCEDURE IncreaseSpriteHCBrightness(SourSprite:VirtualWindow;r,g,b:Byte;    HideColor:Word);

 PROCEDURE CopySprite(Sour,Dest:VirtualWindow);

 PROCEDURE Rotate_Scale_Sprite  (Sour,Dest:VirtualWindow;x,y,Breite,Hoehe,Winkel:LongInt);
 PROCEDURE Rotate_Scale_SpriteHC(Sour,Dest:VirtualWindow;x,y,Breite,Hoehe,Winkel:LongInt;Hcolor:Word);

 PROCEDURE Rotate_Sprite180(Sour,Dest:VirtualWindow);

{---------------------------------------------------------------------------}



IMPLEMENTATION


CONST  Copyright = 'Copyright (c) 2002 by venom, VENOM Software. All rights reserved.';

       PositiveRGBMaske    : TMMXByte = ( 0, 1, 2, 1, 0, 1, 2, 1);
       NegativeRGBMaske    : TMMXByte = (-1,-2,-1, 0,-1,-2,-1, 0);

VAR    Loop1,Loop2,Loop3   : LongInt;
       TempZeiger          : Pointer;
       LinePosition        : Array[0..2000] of LongInt;
       TempVar1            : Word;
       rgbtemp1            : TMMXByte;
       rgbtemp2            : TMMXByte;











{---------------------------------------------------------------------------}



PROCEDURE Load_Sprite(Datei,BigDatei:String;Var Sprite:VirtualWindow);
Begin
 If BigDatei<>''
 then BigFileSpr2Mem(Datei,BigDatei,Memory,Loop3)
 else    FileSpr2Mem(Datei         ,Memory,Loop3);

 CalculateVW(Sprite,Longint(Word(Loop3)),Loop3 shr 16);

 Sprite.VWOffset    := Longint(Memory);
 Sprite.Active      := True;
 Sprite.OptionalPath:= Datei;
End;



PROCEDURE Save_Sprite(Datei:String;var Sprite:VirtualWindow);
VAR       Dat             : File;
Begin
 If FileOverWrite(Datei) then
 begin
  Assign(Dat,Datei);
  {$I-}
  Rewrite(Dat,2);
  {$I+}
  If IOResult<>0 then ERRORM(IO_ErrorHeadline,IO_ErrorWriteAccess+#13+#13+'File : '+Datei);
  BlockWrite(Dat,Pointer(Sprite.VWOffset)^,Sprite.Size shr 1);
  Loop3:=Sprite.Breite+(Sprite.Hoehe shl 16);
  BlockWrite(Dat,Addr(Loop3)^,2);
  Close(Dat);
 end;
End;



PROCEDURE Load_HWL(Datei,BigDatei:String;Var Sprite:VirtualWindow);
Begin

End;



PROCEDURE Load_PCX(Datei,BigDatei:String;Var Sprite:VirtualWindow);
VAR       PCX_Byte1     : Byte;
          PCX_Loop      : Longint;
          PCX_FileSize  : Longint;
          PCX_Buffer    : Longint;
          PCX_FilePos   : Longint;
          PCX_Offset    : Longint;
          PCX_BufferOfs : Longint;
          PCX_IntOffset : Longint;
          PCX_DataSize  : Longint;
          PCX_Breite    : LongInt;
          PCX_ByteBreite: LongInt;
          PCX_ScanlPos  : LongInt;
          PCX_OddBreite : LongInt;
          PCX_Header    : Record
                           Manufacturer      : Byte;
                           Version           : Byte;
                           Encoding          : Byte;
                           BitsPerPixel      : Byte;
                           xmin,ymin         : Word;
                           xmax,ymax         : Word;
                           Hdpi,Vdpi         : Word;
                           Palette           : Array[0..47] of Byte;
                           Reserved          : Byte;
                           ColorPlanes       : Byte;
                           BytesPerLine      : Word;
                           PalettenInfo      : Word;
                           H_ScreenSize      : Word;
                           V_ScreenSize      : Word;
                           CTM_definedYMax   : Word;
                           CTM_definedXMax   : Word;
                           Nothing_else_shit : Array[1..52] of Byte;
                          End;
BEGIN

 If BigDatei<>''
 then PCX_FileSize:= BigFile2Mem(Datei,BigDatei,Memory)
 else PCX_FileSize:=    File2Mem(Datei         ,Memory);


 (******* Load PCX header and set window parameters ************************)

 Move(Memory^,PCX_Header,128);

 If PCX_Header.Manufacturer<>10 then ERRORM('FILE ERROR','Following file has not a valid pcx format : '     +Datei);
 If PCX_Header.Encoding    <> 1 then ERRORM('FILE ERROR','Following pcx file is not compressed : '          +Datei);
 If PCX_Header.ColorPlanes <> 3 then ERRORM('FILE ERROR','Following file is not a 24 Bit 64 Kb color pcx : '+Datei);

 Sprite.Breite:= PCX_Header.xmax-PCX_Header.xmin+1;
 If Odd(Sprite.Breite) then
 begin
  PCX_OddBreite:= Sprite.Breite;
  Inc(Sprite.Breite);
 end else PCX_OddBreite:= 99999;
 Init_VW(Sprite,Sprite.Breite,PCX_Header.ymax-PCX_Header.ymin+1,false);
 Sprite.OptionalPath:= Datei;


 (******* Load and decode PCX Data *****************************************)

 PCX_Buffer:= 0;
 ALLOKSPEICHER(PCX_Buffer,PCX_FileSize -128);

 Move(Pointer(Memory+128)^,Pointer(PCX_Buffer)^,PCX_FileSize -128);

 PCX_Breite        :=Sprite.Breite;
 PCX_ByteBreite    :=Sprite.ByteBreite;
 PCX_Offset        :=Sprite.VWOffset;
 PCX_BufferOfs     :=PCX_Buffer;


 FOR PCX_Loop :=1 TO Sprite.Hoehe DO
 Asm

   Mov PCX_ScanlPos,0                  { RED PLANE }
   Mov eax,PCX_Offset
   Mov PCX_IntOffset,eax
   Mov edx,PCX_OddBreite
   @RED_LOOP:

    Mov esi,PCX_BufferOfs
    Mov al,[esi]
    Mov PCX_Byte1,al
    Inc PCX_BufferOfs

    Cmp PCX_ScanlPos,edx
    Jne @DerSchwarzZuSetzendeRandIstNochNichtErreicht
     Mov PCX_Byte1,0
    @DerSchwarzZuSetzendeRandIstNochNichtErreicht:

    And al,192
    Cmp al,192
    Jne @NurEinByteKopieren1

    Mov esi,PCX_BufferOfs              { Mehrere Bytes kopieren }
    Mov al,[esi]
    Inc PCX_BufferOfs

    Xor PCX_Byte1,192
    Xor ah,ah
    Shr al,3
    Shl ax,11
    Mov esi,PCX_IntOffset
    @LOOP1:

     Mov [esi],ax
     Add esi,2
     Inc PCX_ScanlPos

    Dec PCX_Byte1
    JNZ @LOOP1
    Mov PCX_IntOffset,esi
    Jmp @Ende1

    @NurEinByteKopieren1:

    Mov esi,PCX_IntOffset              { Nur ein Byte kopieren }
    Xor ah,ah
    Mov al,PCX_Byte1
    Shr al,3
    Shl ax,11
    Mov [esi],ax
    Inc PCX_ScanlPos
    Add PCX_IntOffset,2
    @ENDE1:

   Mov eax,PCX_Breite
   Cmp PCX_ScanlPos,eax
   Jl @RED_LOOP




   Mov PCX_ScanlPos,0                  { GREEN PLANE }
   Mov eax,PCX_Offset
   Mov PCX_IntOffset,eax
   @GREEN_LOOP:

    Mov esi,PCX_BufferOfs
    Mov al,[esi]
    Mov PCX_Byte1,al
    Inc PCX_BufferOfs

    Cmp PCX_ScanlPos,edx
    Jne @DerSchwarzZuSetzendeRandIstNochNichtErreicht2
     Mov PCX_Byte1,0
    @DerSchwarzZuSetzendeRandIstNochNichtErreicht2:

    And al,192
    Cmp al,192
    Jne @NurEinByteKopieren2

    Mov esi,PCX_BufferOfs              { Mehrere Bytes kopieren }
    Mov al,[esi]
    Inc PCX_BufferOfs

    Xor PCX_Byte1,192
    Xor ah,ah
    Shr al,2
    Shl ax,5
    Mov esi,PCX_IntOffset
    @LOOP2:

     Add [esi],ax
     Add esi,2
     Inc PCX_ScanlPos

    Dec PCX_Byte1
    JNZ @LOOP2
    Mov PCX_IntOffset,esi
    Jmp @Ende2

    @NurEinByteKopieren2:

    Mov esi,PCX_IntOffset              { Nur ein Byte kopieren }
    Xor ah,ah
    Mov al,PCX_Byte1
    Shr al,2
    Shl ax,5
    Add [esi],ax
    Inc PCX_ScanlPos
    Add PCX_IntOffset,2
    @ENDE2:

   Mov eax,PCX_Breite
   Cmp PCX_ScanlPos,eax
   Jl @GREEN_LOOP




   Mov PCX_ScanlPos,0                  { BLUE PLANE }
   Mov eax,PCX_Offset
   Mov PCX_IntOffset,eax
   @BLUE_LOOP:

    Mov esi,PCX_BufferOfs
    Mov al,[esi]
    Mov PCX_Byte1,al
    Inc PCX_BufferOfs

    Cmp PCX_ScanlPos,edx
    Jne @DerSchwarzZuSetzendeRandIstNochNichtErreicht3
     Mov PCX_Byte1,0
    @DerSchwarzZuSetzendeRandIstNochNichtErreicht3:

    And al,192
    Cmp al,192
    Jne @NurEinByteKopieren3

    Mov esi,PCX_BufferOfs
    Mov al,[esi]
    Inc PCX_BufferOfs

    Xor PCX_Byte1,192
    Xor ah,ah
    Shr al,3
    Mov esi,PCX_IntOffset
    @LOOP3:

     Add [esi],ax
     Add esi,2
     Inc PCX_ScanlPos

    Dec PCX_Byte1
    JNZ @LOOP3
    Mov PCX_IntOffset,esi
    Jmp @Ende3

    @NurEinByteKopieren3:

    Mov esi,PCX_IntOffset              { Nur ein Byte kopieren }
    Xor ah,ah
    Mov al,PCX_Byte1
    Shr al,3
    Add [esi],ax
    Inc PCX_ScanlPos
    Add PCX_IntOffset,2
    @ENDE3:

   Mov eax,PCX_Breite
   Cmp PCX_ScanlPos,eax
   Jl @BLUE_LOOP

   Mov eax,PCX_ByteBreite
   Add PCX_Offset,eax
 END;

 Sprite.Active:= True;

 FreeSpeicher(PCX_Buffer);

 FreePtrSpeicher(Memory);
END;



PROCEDURE PutSprite(Dest,Sprite:VirtualWindow;x,y:LongInt);
Begin
 Asm

  Push es
  Mov ax,ds
  Mov es,ax

  Mov  eax,Dest.ByteBreite        { Destination Offset bestimmen }
  Mul  y
  Shl  x,1
  Add  eax,x
  Add  eax,Dest.VWOffset
  Mov  edi,eax
  Mov  ebx,eax                { Und in ebx festhalten }

  Mov  esi,Sprite.VWOffset       { Sprite Offset in esi }

  Mov  edx,Sprite.Hoehe
  @SCANLINES_LOOP:

    Mov ecx,Sprite.BreiteDiv2
    Rep MovsD
    Mov ecx,Sprite.BreiteMod2
    Rep MovsW

    Add ebx,Dest.ByteBreite
    Mov edi,ebx

  Dec edx
  JNZ @SCANLINES_LOOP
  Pop es
 END;
End;




PROCEDURE GetSprite(Source:VirtualWindow;Sprite:VirtualWindow;x,y:LongInt);
Begin
 Asm
  Push es

  Mov  ax,ds
  Mov  es,ax

  Mov  eax,Source.ByteBreite      { Source Offset bestimmen }
  Mul  y
  Shl  x,1
  Add  eax,x
  Add  eax,Source.VWOffset
  Mov  esi,eax
  Mov  ebx,eax                { Und in ebx festhalten }

  Mov  edi,Sprite.VWOffset       { Sprite Offset in edi }

  Mov  edx,Sprite.Hoehe
  @SCANLINES_LOOP:

    Mov ecx,Sprite.BreiteDiv2
    Rep MovsD
    Mov ecx,Sprite.BreiteMod2
    Rep MovsW

    Add ebx,Source.ByteBreite
    Mov esi,ebx

  Dec edx
  JNZ @SCANLINES_LOOP
  Pop es
 END;
End;




PROCEDURE PutClippedSprite(Dest,Sprite:VirtualWindow;x,y:LongInt);
VAR       L_SpriteBorder : LongInt;
          R_SpriteBorder : LongInt;
          U_SpriteBorder : LongInt;
          B_SpriteBorder : LongInt;
          L_DestBorder   : LongInt;
          U_DestBorder   : LongInt;
          ScanLine       : LongInt;
          ScanLineRest   : LongInt;
          ScanLines,bbb  : LongInt;
Begin
 Asm
  Mov eax,x
  Cmp eax,Dest.Breite
  Jge @Ende
  Add eax,Sprite.Breite
  Cmp eax,1
  Jl  @Ende

  Mov ebx,y
  Cmp ebx,Dest.Hoehe
  Jge @Ende
  Add ebx,Sprite.Hoehe
  Cmp ebx,1
  Jl  @Ende

  Push ebx                         { y + Sprite.Hoehe  sichern }
  Push eax                         { x + Sprite.Breite sichern }

  Mov eax,x
  Cmp eax,0
  Jge @JumpTo1
   Neg eax
   Mov L_SpriteBorder,eax
   Mov L_DestBorder,0
   Jmp @JumpTo2
  @JumpTo1:
   Mov L_SpriteBorder,0
   Mov L_DestBorder,eax
  @JumpTo2:

  Mov eax,y
  Cmp eax,0
  Jge @JumpTo3
   Neg eax
   Mov U_SpriteBorder,eax
   Mov U_DestBorder,0
   Jmp @JumpTo4
  @JumpTo3:
   Mov U_SpriteBorder,0
   Mov U_DestBorder,eax
  @JumpTo4:

  Pop eax
  Cmp eax,Dest.Breite
  Jg @JumpTo5
   Mov eax,Sprite.Breite
   Mov R_SpriteBorder,eax
   Jmp @JumpTo6
  @JumpTo5:
   Mov eax,Dest.Breite
   Sub eax,x
   Mov R_SpriteBorder,eax
  @JumpTo6:

  Pop eax
  Cmp eax,Dest.Hoehe
  Jg @JumpTo7
   Mov eax,Sprite.Hoehe
   Mov B_SpriteBorder,eax
   Jmp @JumpTo8
  @JumpTo7:
   Mov eax,Dest.Hoehe
   Sub eax,y
   Mov B_SpriteBorder,eax
  @JumpTo8:

  Mov eax,R_SpriteBorder           { Gre der Scanline berechnen }
  Sub eax,L_SpriteBorder
  Mov ScanLine,eax

  Mov eax,B_SpriteBorder           { Anzahl der Scanlines berechnen }
  Sub eax,U_SpriteBorder
  Mov ScanLines,eax

  Shl L_SpriteBorder,1             { An 16 Bit anpassen }
  Shl L_DestBorder,1

  Push es
  Mov ax,ds                         { Zielsegment in es laden }
  Mov es,ax

  Mov esi,Sprite.VWOffset            { Offset im Sprite bestimmen (Quelle) }
  Mov eax,U_SpriteBorder
  Mul Sprite.ByteBreite
  Add eax,L_SpriteBorder
  Add esi,eax

  Mov edi,Dest.VWOffset              { Offset im Speicher bestimmen (Ziel) }
  Mov eax,U_DestBorder
  Mul Dest.ByteBreite
  Add eax,L_DestBorder
  Add edi,eax

  Mov ebx,edi                     { Startoffsets in xxx und ebx festhalten }
  Mov bbb,esi

  Xor edx,edx
  Mov eax,ScanLine
  Mov ecx,2
  Div ecx
  Mov ScanLine    ,eax
  Mov ScanLineRest,edx

  @SCANLINES_LOOP:

    Mov  ecx,ScanLine
    Rep  MovsD
    Mov  ecx,ScanLineRest
    Rep  MovsW

    Add  ebx,Dest.ByteBreite       { StartOffsets mit Breiten addieren }
    Mov  edi,ebx

    Mov  edx,Sprite.ByteBreite
    Add  bbb,edx
    Mov  esi,bbb

  Dec ScanLines                    { Scanline-Counter runter zhlen }
  JNZ @SCANLINES_LOOP

  Pop es

  @ENDE:
 End;
End;




PROCEDURE GetClippedSprite(Source:VirtualWindow;Sprite:VirtualWindow;x,y:LongInt);
VAR       L_SpriteBorder : LongInt;
          R_SpriteBorder : LongInt;
          U_SpriteBorder : LongInt;
          B_SpriteBorder : LongInt;
          L_SourceBorder : LongInt;
          U_SourceBorder : LongInt;
          ScanLine       : LongInt;
          ScanLineRest   : LongInt;
          ScanLines,bbb  : LongInt;
Begin
 Asm
  Mov eax,x
  Cmp eax,Source.Breite
  Jge @Ende
  Add eax,Sprite.Breite
  Cmp eax,1
  Jl  @Ende

  Mov ebx,y
  Cmp ebx,Source.Hoehe
  Jge @Ende
  Add ebx,Sprite.Hoehe
  Cmp ebx,1
  Jl  @Ende

  Push ebx                         { y + Sprite.Hoehe  sichern }
  Push eax                         { x + Sprite.Breite sichern }

  Mov eax,x
  Cmp eax,0
  Jge @JumpTo1
   Neg eax
   Mov L_SpriteBorder,eax
   Mov L_SourceBorder,0
   Jmp @JumpTo2
  @JumpTo1:
   Mov L_SpriteBorder,0
   Mov L_SourceBorder,eax
  @JumpTo2:

  Mov eax,y
  Cmp eax,0
  Jge @JumpTo3
   Neg eax
   Mov U_SpriteBorder,eax
   Mov U_SourceBorder,0
   Jmp @JumpTo4
  @JumpTo3:
   Mov U_SpriteBorder,0
   Mov U_SourceBorder,eax
  @JumpTo4:

  Pop eax
  Cmp eax,Source.Breite
  Jg @JumpTo5
   Mov eax,Sprite.Breite
   Mov R_SpriteBorder,eax
   Jmp @JumpTo6
  @JumpTo5:
   Mov eax,Source.Breite
   Sub eax,x
   Mov R_SpriteBorder,eax
  @JumpTo6:

  Pop eax
  Cmp eax,Source.Hoehe
  Jg @JumpTo7
   Mov eax,Sprite.Hoehe
   Mov B_SpriteBorder,eax
   Jmp @JumpTo8
  @JumpTo7:
   Mov eax,Source.Hoehe
   Sub eax,y
   Mov B_SpriteBorder,eax
  @JumpTo8:

  Mov eax,R_SpriteBorder           { Gre der Scanline berechnen }
  Sub eax,L_SpriteBorder
  Mov ScanLine,eax

  Mov eax,B_SpriteBorder           { Anzahl der Scanlines berechnen }
  Sub eax,U_SpriteBorder
  Mov ScanLines,eax

  Shl L_SpriteBorder,1             { An 16 Bit anpassen }
  Shl L_SourceBorder,1

  Push es
  Mov  ax,ds
  Mov  es,ax

  Mov edi,Sprite.VWOffset            { Offset im Sprite bestimmen (Ziel) }
  Mov eax,U_SpriteBorder
  Mul Sprite.ByteBreite
  Add eax,L_SpriteBorder
  Add edi,eax

  Mov esi,Source.VWOffset            { Offset im Speicher bestimmen (Quelle) }
  Mov eax,U_SourceBorder
  Mul Source.ByteBreite
  Add eax,L_SourceBorder
  Add esi,eax

  Mov ebx,edi                     { Startoffsets in xxx und ebx festhalten }
  Mov bbb,esi

  Xor edx,edx
  Mov eax,ScanLine
  Mov ecx,2
  Div ecx
  Mov ScanLine    ,eax
  Mov ScanLineRest,edx

  @SCANLINES_LOOP:

    Mov  ecx,ScanLine
    Rep  MovsD
    Mov  ecx,ScanLineRest
    Rep  MovsW

    Add  ebx,Sprite.ByteBreite     { StartOffsets mit Breiten addieren }
    Mov  edi,ebx

    Mov  edx,Source.ByteBreite
    Add  bbb,edx
    Mov  esi,bbb

  Dec ScanLines                    { Scanline-Counter runter zhlen }
  JNZ @SCANLINES_LOOP

  Pop es

  @ENDE:
 End;
End;




PROCEDURE PutHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);
Begin
 Asm
  Mov eax,Dest.ByteBreite        { Destination Offset bestimmen }
  Mul y
  Shl x,1
  Add eax,x
  Add eax,Dest.VWOffset
  Mov edi,eax
  Mov ebx,eax                    { Und in ebx festhalten }

  Mov esi,Sprite.VWOffset           { Sprite Offset in esi }

  Mov edx,Sprite.Hoehe
  @SCANLINES_LOOP:

    Mov ecx,Sprite.Breite
    @SCANLINE_LOOP:

     Mov ax,[esi]
     Cmp ax,HideColor
     Je @FarbeNichtSetzen

     Mov [edi],ax
     @FarbeNichtSetzen:

     Add esi,2
     Add edi,2

    Loop @SCANLINE_LOOP

    Add ebx,Dest.ByteBreite
    Mov edi,ebx

  Dec edx
  JNZ @SCANLINES_LOOP
 END;
End;




PROCEDURE GetHCSprite(Source:VirtualWindow;Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);
Begin
 Asm
  Mov eax,Source.ByteBreite      { Source Offset bestimmen }
  Mul y
  Shl x,1
  Add eax,x
  Add eax,Source.VWOffset
  Mov esi,eax
  Mov ebx,eax                { Und in ebx festhalten }

  Mov edi,Sprite.VWOffset       { Sprite Offset in edi }

  Mov edx,Sprite.Hoehe
  @SCANLINES_LOOP:

    Mov ecx,Sprite.Breite
    @SCANLINE_LOOP:

     Mov ax,[esi]
     Cmp ax,HideColor
     Je @FarbeNichtSetzen

     Mov [edi],ax
     @FarbeNichtSetzen:

     Add esi,2
     Add edi,2

    Loop @SCANLINE_LOOP

    Add ebx,Source.ByteBreite
    Mov esi,ebx

  Dec edx
  JNZ @SCANLINES_LOOP
 END;
End;




PROCEDURE PutClippedHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);
VAR       L_SpriteBorder : LongInt;
          R_SpriteBorder : LongInt;
          U_SpriteBorder : LongInt;
          B_SpriteBorder : LongInt;
          L_DestBorder   : LongInt;
          U_DestBorder   : LongInt;
          ScanLine       : LongInt;
          ScanLines,bbb  : LongInt;
Begin
 Asm
  Mov eax,x
  Cmp eax,Dest.Breite
  Jge @Ende
  Add eax,Sprite.Breite
  Cmp eax,1
  Jl  @Ende

  Mov ebx,y
  Cmp ebx,Dest.Hoehe
  Jge @Ende
  Add ebx,Sprite.Hoehe
  Cmp ebx,1
  Jl  @Ende

  Push ebx                         { y + Sprite.Hoehe  sichern }
  Push eax                         { x + Sprite.Breite sichern }

  Mov eax,x
  Cmp eax,0
  Jge @JumpTo1
   Neg eax
   Mov L_SpriteBorder,eax
   Mov L_DestBorder,0
   Jmp @JumpTo2
  @JumpTo1:
   Mov L_SpriteBorder,0
   Mov L_DestBorder,eax
  @JumpTo2:

  Mov eax,y
  Cmp eax,0
  Jge @JumpTo3
   Neg eax
   Mov U_SpriteBorder,eax
   Mov U_DestBorder,0
   Jmp @JumpTo4
  @JumpTo3:
   Mov U_SpriteBorder,0
   Mov U_DestBorder,eax
  @JumpTo4:

  Pop eax
  Cmp eax,Dest.Breite
  Jg @JumpTo5
   Mov eax,Sprite.Breite
   Mov R_SpriteBorder,eax
   Jmp @JumpTo6
  @JumpTo5:
   Mov eax,Dest.Breite
   Sub eax,x
   Mov R_SpriteBorder,eax
  @JumpTo6:

  Pop eax
  Cmp eax,Dest.Hoehe
  Jg @JumpTo7
   Mov eax,Sprite.Hoehe
   Mov B_SpriteBorder,eax
   Jmp @JumpTo8
  @JumpTo7:
   Mov eax,Dest.Hoehe
   Sub eax,y
   Mov B_SpriteBorder,eax
  @JumpTo8:

  Mov eax,R_SpriteBorder           { Gre der Scanline berechnen }
  Sub eax,L_SpriteBorder
  Mov ScanLine,eax

  Mov eax,B_SpriteBorder           { Anzahl der Scanlines berechnen }
  Sub eax,U_SpriteBorder
  Mov ScanLines,eax

  Shl L_SpriteBorder,1             { An 16 Bit anpassen }
  Shl L_DestBorder,1

  Mov esi,Sprite.VWOffset            { Offset im Sprite bestimmen (Quelle) }
  Mov eax,U_SpriteBorder
  Mul Sprite.ByteBreite
  Add eax,L_SpriteBorder
  Add esi,eax

  Mov edi,Dest.VWOffset              { Offset im Speicher bestimmen (Ziel) }
  Mov eax,U_DestBorder
  Mul Dest.ByteBreite
  Add eax,L_DestBorder
  Add edi,eax

  Mov ebx,edi                     { Startoffsets in xxx und ebx festhalten }
  Mov bbb,esi

  @SCANLINES_LOOP:

    Mov ecx,ScanLine
    @SCANLINE_LOOP:

     Mov ax,[esi]
     Cmp ax,HideColor
     Je @FarbeNichtSetzen

     Mov [edi],ax
     @FarbeNichtSetzen:

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Add  ebx,Dest.ByteBreite       { StartOffsets mit Breiten addieren }
    Mov  edi,ebx

    Mov  edx,Sprite.ByteBreite
    Add  bbb,edx
    Mov  esi,bbb

  Dec ScanLines                    { Scanline-Counter runter zhlen }
  JNZ @SCANLINES_LOOP

  @ENDE:
 End;
End;




PROCEDURE GetClippedHCSprite(Source:VirtualWindow;Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);
VAR       L_SpriteBorder : LongInt;
          R_SpriteBorder : LongInt;
          U_SpriteBorder : LongInt;
          B_SpriteBorder : LongInt;
          L_SourceBorder : LongInt;
          U_SourceBorder : LongInt;
          ScanLine       : LongInt;
          ScanLines,bbb  : LongInt;
Begin
 Asm
  Mov eax,x
  Cmp eax,Source.Breite
  Jge @Ende
  Add eax,Sprite.Breite
  Cmp eax,1
  Jl  @Ende

  Mov ebx,y
  Cmp ebx,Source.Hoehe
  Jge @Ende
  Add ebx,Sprite.Hoehe
  Cmp ebx,1
  Jl  @Ende

  Push ebx                         { y + Sprite.Hoehe  sichern }
  Push eax                         { x + Sprite.Breite sichern }

  Mov eax,x
  Cmp eax,0
  Jge @JumpTo1
   Neg eax
   Mov L_SpriteBorder,eax
   Mov L_SourceBorder,0
   Jmp @JumpTo2
  @JumpTo1:
   Mov L_SpriteBorder,0
   Mov L_SourceBorder,eax
  @JumpTo2:

  Mov eax,y
  Cmp eax,0
  Jge @JumpTo3
   Neg eax
   Mov U_SpriteBorder,eax
   Mov U_SourceBorder,0
   Jmp @JumpTo4
  @JumpTo3:
   Mov U_SpriteBorder,0
   Mov U_SourceBorder,eax
  @JumpTo4:

  Pop eax
  Cmp eax,Source.Breite
  Jg @JumpTo5
   Mov eax,Sprite.Breite
   Mov R_SpriteBorder,eax
   Jmp @JumpTo6
  @JumpTo5:
   Mov eax,Source.Breite
   Sub eax,x
   Mov R_SpriteBorder,eax
  @JumpTo6:

  Pop eax
  Cmp eax,Source.Hoehe
  Jg @JumpTo7
   Mov eax,Sprite.Hoehe
   Mov B_SpriteBorder,eax
   Jmp @JumpTo8
  @JumpTo7:
   Mov eax,Source.Hoehe
   Sub eax,y
   Mov B_SpriteBorder,eax
  @JumpTo8:

  Mov eax,R_SpriteBorder           { Gre der Scanline berechnen }
  Sub eax,L_SpriteBorder
  Mov ScanLine,eax

  Mov eax,B_SpriteBorder           { Anzahl der Scanlines berechnen }
  Sub eax,U_SpriteBorder
  Mov ScanLines,eax

  Shl L_SpriteBorder,1             { An 16 Bit anpassen }
  Shl L_SourceBorder,1

  Mov edi,Sprite.VWOffset             { Offset im Sprite bestimmen (Ziel) }
  Mov eax,U_SpriteBorder
  Mul Sprite.ByteBreite
  Add eax,L_SpriteBorder
  Add edi,eax

  Mov esi,Source.VWOffset             { Offset im Speicher bestimmen (Quelle) }
  Mov eax,U_SourceBorder
  Mul Source.ByteBreite
  Add eax,L_SourceBorder
  Add esi,eax

  Mov ebx,edi                      { Startoffsets in xxx und ebx festhalten }
  Mov bbb,esi

  @SCANLINES_LOOP:

    Mov ecx,ScanLine
    @SCANLINE_LOOP:

     Mov ax,[esi]
     Cmp ax,HideColor
     Je  @FarbeNichtSetzen

     Mov [edi],ax
     @FarbeNichtSetzen:

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Add  ebx,Sprite.ByteBreite     { StartOffsets mit Breiten addieren }
    Mov  edi,ebx

    Mov  edx,Source.ByteBreite
    Add  bbb,edx
    Mov  esi,bbb

  Dec ScanLines                    { Scanline-Counter runter zhlen }
  JNZ @SCANLINES_LOOP

  @ENDE:
 End;
End;




PROCEDURE PutBrightSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rBright,gBright,bBright:Shortint);
VAR       sr,sg,sb       : Byte;
          bbb            : LongInt;
Begin
 Asm
  Mov  edi,Dest.VWOffset
  Mov  eax,Dest.ByteBreite         { Destination Offset bestimmen }
  Mul  y
  Shl  x,1
  Add  eax,x
  Add  edi,eax
  Mov  bbb,edi

  Mov  esi,Sprite.VWOffset            { Sprite Offset in esi }

  @SCANLINES_LOOP:

    Mov ecx,Sprite.Breite
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }

     Mov dx,ax
     Shr ax,3
     Sub ah,rBright
     Cmp ah,0
     Jge @Jump1
      Xor ah,ah
     @Jump1:
     Mov sr,ah
     Shr al,2
     Sub al,gBright
     Cmp al,0
     Jge @Jump2
      Xor al,al
     @Jump2:
     Mov sg,al
     And dl,00011111b
     Sub dl,bBright
     Cmp dl,0
     Jge @Jump3
      Xor dl,dl
     @Jump3:
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }

     Mov dx,bx
     Shr bx,3               {  rot in bh }
     Shr bl,2               { grn in bl }
     And dl,00011111b       { blau in dl }

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Cmp bh,32
     Jb @NoChange1
      Mov bh,31
     @NoChange1:
     Cmp bl,64
     Jb @NoChange2
      Mov bl,63
     @NoChange2:
     Cmp dl,32
     Jb @NoChange3
      Mov dl,31
     @NoChange3:

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov eax,Dest.ByteBreite
    Add bbb,eax
    Mov edi,bbb

  Dec Sprite.Hoehe
  JNZ @SCANLINES_LOOP
 END;
End;




PROCEDURE PutBrightClippedSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rBright,gBright,bBright:ShortInt);
VAR       L_SpriteBorder : LongInt;
          R_SpriteBorder : LongInt;
          U_SpriteBorder : LongInt;
          B_SpriteBorder : LongInt;
          L_DestBorder   : LongInt;
          U_DestBorder   : LongInt;
          ScanLine       : LongInt;
          ScanLines      : LongInt;
          xxx,bbb        : LongInt;
          sr,sg,sb       : Byte;
Begin
 Asm
  Mov eax,x
  Cmp eax,Dest.Breite
  Jge @Ende
  Add eax,Sprite.Breite
  Cmp eax,1
  Jl  @Ende

  Mov ebx,y
  Cmp ebx,Dest.Hoehe
  Jge @Ende
  Add ebx,Sprite.Hoehe
  Cmp ebx,1
  Jl  @Ende

  Push ebx                         { y + Sprite.Hoehe  sichern }
  Push eax                         { x + Sprite.Breite sichern }

  Mov eax,x
  Cmp eax,0
  Jge @JumpTo1
   Neg eax
   Mov L_SpriteBorder,eax
   Mov L_DestBorder,0
   Jmp @JumpTo2
  @JumpTo1:
   Mov L_SpriteBorder,0
   Mov L_DestBorder,eax
  @JumpTo2:

  Mov eax,y
  Cmp eax,0
  Jge @JumpTo3
   Neg eax
   Mov U_SpriteBorder,eax
   Mov U_DestBorder,0
   Jmp @JumpTo4
  @JumpTo3:
   Mov U_SpriteBorder,0
   Mov U_DestBorder,eax
  @JumpTo4:

  Pop eax
  Cmp eax,Dest.Breite
  Jg @JumpTo5
   Mov eax,Sprite.Breite
   Mov R_SpriteBorder,eax
   Jmp @JumpTo6
  @JumpTo5:
   Mov eax,Dest.Breite
   Sub eax,x
   Mov R_SpriteBorder,eax
  @JumpTo6:

  Pop eax
  Cmp eax,Dest.Hoehe
  Jg @JumpTo7
   Mov eax,Sprite.Hoehe
   Mov B_SpriteBorder,eax
   Jmp @JumpTo8
  @JumpTo7:
   Mov eax,Dest.Hoehe
   Sub eax,y
   Mov B_SpriteBorder,eax
  @JumpTo8:

  Mov eax,R_SpriteBorder           { Gre der Scanline berechnen }
  Sub eax,L_SpriteBorder
  Mov ScanLine,eax

  Mov eax,B_SpriteBorder           { Anzahl der Scanlines berechnen }
  Sub eax,U_SpriteBorder
  Mov ScanLines,eax

  Shl L_SpriteBorder,1             { An 16 Bit anpassen }
  Shl L_DestBorder,1

  Mov esi,Sprite.VWOffset             { Offset im Sprite bestimmen (Quelle) }
  Mov eax,U_SpriteBorder
  Mul Sprite.ByteBreite
  Add eax,L_SpriteBorder
  Add esi,eax

  Mov edi,Dest.VWOffset               { Offset im Speicher bestimmen (Ziel) }
  Mov eax,U_DestBorder
  Mul Dest.ByteBreite
  Add eax,L_DestBorder
  Add edi,eax

  Mov bbb,edi                      { Startoffsets in xxx und ebx festhalten }
  Mov xxx,esi

  @SCANLINES_LOOP:

    Mov ecx,ScanLine
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }

     Mov dx,ax
     Shr ax,3
     Sub ah,rBright
     Cmp ah,0
     Jge @Jump1
      Xor ah,ah
     @Jump1:
     Mov sr,ah
     Shr al,2
     Sub al,gBright
     Cmp al,0
     Jge @Jump2
      Xor al,al
     @Jump2:
     Mov sg,al
     And dl,00011111b
     Sub dl,bBright
     Cmp dl,0
     Jge @Jump3
      Xor dl,dl
     @Jump3:
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }

     Mov dx,bx
     Shr bx,3               {  rot in ah }
     Shr bl,2               { grn in bl }
     And dl,00011111b       { blau in dl }

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Cmp bh,32
     Jb @NoChange1
      Mov bh,31
     @NoChange1:
     Cmp bl,64
     Jb @NoChange2
      Mov bl,63
     @NoChange2:
     Cmp dl,32
     Jb @NoChange3
      Mov dl,31
     @NoChange3:

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov eax,Dest.ByteBreite
    Add bbb,eax
    Mov edi,bbb

    Mov  edx,Sprite.ByteBreite
    Add  xxx,edx
    Mov  esi,xxx

  Dec ScanLines
  JNZ @SCANLINES_LOOP

  @ENDE:
 End;
End;




PROCEDURE PutBrightHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rBright,gBright,bBright:ShortInt;HideColor:Word);
VAR       sr,sg,sb       : Byte;
          bbb            : LongInt;
Begin
 Asm
  Mov eax,Dest.ByteBreite              { Destination Offset bestimmen }
  Mul y
  Shl x,1
  Add eax,x
  Add eax,Dest.VWOffset
  Mov edi,eax
  Mov bbb,eax

  Mov esi,Sprite.VWOffset             { Sprite Offset in esi }

  @SCANLINES_LOOP:

    Mov ecx,Sprite.Breite
    @SCANLINE_LOOP:

     Mov ax,[esi]                     { Load Sprite r,g,b }
     Cmp ax,HideColor
     Je @FarbeNichtSetzen

     Mov dx,ax
     Shr ax,3
     Sub ah,rBright
     Cmp ah,0
     Jge @Jump1
      Xor ah,ah
     @Jump1:
     Mov sr,ah
     Shr al,2
     Sub al,gBright
     Cmp al,0
     Jge @Jump2
      Xor al,al
     @Jump2:
     Mov sg,al
     And dl,00011111b
     Sub dl,bBright
     Cmp dl,0
     Jge @Jump3
      Xor dl,dl
     @Jump3:
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }

     Mov dx,bx
     Shr bx,3               {  rot in bh }
     Shr bl,2               { grn in bl }
     And dl,00011111b       { blau in dl }

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Cmp bh,32
     Jb @NoChange1
      Mov bh,31
     @NoChange1:
     Cmp bl,64
     Jb @NoChange2
      Mov bl,63
     @NoChange2:
     Cmp dl,32
     Jb @NoChange3
      Mov dl,31
     @NoChange3:

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax
     @FarbeNichtSetzen:

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov eax,Dest.ByteBreite
    Add bbb,eax
    Mov edi,bbb

  Dec Sprite.Hoehe
  JNZ @SCANLINES_LOOP
 END;
End;




PROCEDURE PutBrightClippedHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rBright,gBright,bBright:ShortInt;HideColor:Word);
VAR       L_SpriteBorder : LongInt;
          R_SpriteBorder : LongInt;
          U_SpriteBorder : LongInt;
          B_SpriteBorder : LongInt;
          L_DestBorder   : LongInt;
          U_DestBorder   : LongInt;
          ScanLine       : LongInt;
          ScanLines      : LongInt;
          xxx,bbb        : LongInt;
          sr,sg,sb       : Byte;
Begin
 Asm
  Mov eax,x
  Cmp eax,Dest.Breite
  Jge @Ende
  Add eax,Sprite.Breite
  Cmp eax,1
  Jl  @Ende

  Mov ebx,y
  Cmp ebx,Dest.Hoehe
  Jge @Ende
  Add ebx,Sprite.Hoehe
  Cmp ebx,1
  Jl  @Ende

  Push ebx                         { y + Sprite.Hoehe  sichern }
  Push eax                         { x + Sprite.Breite sichern }

  Mov eax,x
  Cmp eax,0
  Jge @JumpTo1
   Neg eax
   Mov L_SpriteBorder,eax
   Mov L_DestBorder,0
   Jmp @JumpTo2
  @JumpTo1:
   Mov L_SpriteBorder,0
   Mov L_DestBorder,eax
  @JumpTo2:

  Mov eax,y
  Cmp eax,0
  Jge @JumpTo3
   Neg eax
   Mov U_SpriteBorder,eax
   Mov U_DestBorder,0
   Jmp @JumpTo4
  @JumpTo3:
   Mov U_SpriteBorder,0
   Mov U_DestBorder,eax
  @JumpTo4:

  Pop eax
  Cmp eax,Dest.Breite
  Jg @JumpTo5
   Mov eax,Sprite.Breite
   Mov R_SpriteBorder,eax
   Jmp @JumpTo6
  @JumpTo5:
   Mov eax,Dest.Breite
   Sub eax,x
   Mov R_SpriteBorder,eax
  @JumpTo6:

  Pop eax
  Cmp eax,Dest.Hoehe
  Jg @JumpTo7
   Mov eax,Sprite.Hoehe
   Mov B_SpriteBorder,eax
   Jmp @JumpTo8
  @JumpTo7:
   Mov eax,Dest.Hoehe
   Sub eax,y
   Mov B_SpriteBorder,eax
  @JumpTo8:

  Mov eax,R_SpriteBorder           { Gre der Scanline berechnen }
  Sub eax,L_SpriteBorder
  Mov ScanLine,eax

  Mov eax,B_SpriteBorder           { Anzahl der Scanlines berechnen }
  Sub eax,U_SpriteBorder
  Mov ScanLines,eax

  Shl L_SpriteBorder,1             { An 16 Bit anpassen }
  Shl L_DestBorder,1

  Mov esi,Sprite.VWOffset             { Offset im Sprite bestimmen (Quelle) }
  Mov eax,U_SpriteBorder
  Mul Sprite.ByteBreite
  Add eax,L_SpriteBorder
  Add esi,eax

  Mov edi,Dest.VWOffset               { Offset im Speicher bestimmen (Ziel) }
  Mov eax,U_DestBorder
  Mul Dest.ByteBreite
  Add eax,L_DestBorder
  Add edi,eax

  Mov bbb,edi
  Mov xxx,esi

  @SCANLINES_LOOP:

    Mov ecx,ScanLine
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }
     Cmp ax,HideColor
     Je @FarbeNichtSetzen

     Mov dx,ax
     Shr ax,3
     Sub ah,rBright
     Cmp ah,0
     Jge @Jump1
      Xor ah,ah
     @Jump1:
     Mov sr,ah
     Shr al,2
     Sub al,gBright
     Cmp al,0
     Jge @Jump2
      Xor al,al
     @Jump2:
     Mov sg,al
     And dl,00011111b
     Sub dl,bBright
     Cmp dl,0
     Jge @Jump3
      Xor dl,dl
     @Jump3:
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }

     Mov dx,bx
     Shr bx,3               {  rot in ah }
     Shr bl,2               { grn in bl }
     And dl,00011111b       { blau in dl }

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Cmp bh,32
     Jb @NoChange1
      Mov bh,31
     @NoChange1:
     Cmp bl,64
     Jb @NoChange2
      Mov bl,63
     @NoChange2:
     Cmp dl,32
     Jb @NoChange3
      Mov dl,31
     @NoChange3:

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax

     @FarbeNichtSetzen:

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov  eax,Dest.ByteBreite
    Add  bbb,eax
    Mov  edi,bbb

    Mov  edx,Sprite.ByteBreite
    Add  xxx,edx
    Mov  esi,xxx

  Dec ScanLines                    { Scanline-Counter runter zhlen }
  JNZ @SCANLINES_LOOP

  @ENDE:
 End;
End;




PROCEDURE PutMixedSprite(Dest,Sprite:VirtualWindow;x,y:LongInt);
VAR       sr,sg,sb       : Byte;
          bbb            : LongInt;
Begin
 Asm
  Mov  edi,Dest.VWOffset
  Mov  eax,Dest.ByteBreite         { Destination Offset bestimmen }
  Mul  y
  Shl  x,1
  Add  eax,x
  Add  edi,eax
  Mov  bbb,edi

  Mov  esi,Sprite.VWOffset            { Sprite Offset in esi }

  @SCANLINES_LOOP:

    Mov ecx,Sprite.Breite
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }

     Mov dx,ax
     Shr ax,3
     Mov sr,ah
     Shr al,2
     Mov sg,al
     And dl,00011111b
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }

     Mov dx,bx
     Shr bx,3               {  rot in bh }
     Shr bl,2               { grn in bl }
     And dl,00011111b       { blau in dl }

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Shr bh,1
     Shr bl,1
     Shr dl,1

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov eax,Dest.ByteBreite
    Add bbb,eax
    Mov edi,bbb

  Dec Sprite.Hoehe
  JNZ @SCANLINES_LOOP
 END;
End;




PROCEDURE PutMixedClippedSprite(Dest,Sprite:VirtualWindow;x,y:LongInt);
VAR       L_SpriteBorder : LongInt;
          R_SpriteBorder : LongInt;
          U_SpriteBorder : LongInt;
          B_SpriteBorder : LongInt;
          L_DestBorder   : LongInt;
          U_DestBorder   : LongInt;
          ScanLine       : LongInt;
          ScanLines      : LongInt;
          xxx,bbb        : LongInt;
          sr,sg,sb       : Byte;
Begin
 Asm
  Mov eax,x
  Cmp eax,Dest.Breite
  Jge @Ende
  Add eax,Sprite.Breite
  Cmp eax,1
  Jl  @Ende

  Mov ebx,y
  Cmp ebx,Dest.Hoehe
  Jge @Ende
  Add ebx,Sprite.Hoehe
  Cmp ebx,1
  Jl  @Ende

  Push ebx                         { y + Sprite.Hoehe  sichern }
  Push eax                         { x + Sprite.Breite sichern }

  Mov eax,x
  Cmp eax,0
  Jge @JumpTo1
   Neg eax
   Mov L_SpriteBorder,eax
   Mov L_DestBorder,0
   Jmp @JumpTo2
  @JumpTo1:
   Mov L_SpriteBorder,0
   Mov L_DestBorder,eax
  @JumpTo2:

  Mov eax,y
  Cmp eax,0
  Jge @JumpTo3
   Neg eax
   Mov U_SpriteBorder,eax
   Mov U_DestBorder,0
   Jmp @JumpTo4
  @JumpTo3:
   Mov U_SpriteBorder,0
   Mov U_DestBorder,eax
  @JumpTo4:

  Pop eax
  Cmp eax,Dest.Breite
  Jg @JumpTo5
   Mov eax,Sprite.Breite
   Mov R_SpriteBorder,eax
   Jmp @JumpTo6
  @JumpTo5:
   Mov eax,Dest.Breite
   Sub eax,x
   Mov R_SpriteBorder,eax
  @JumpTo6:

  Pop eax
  Cmp eax,Dest.Hoehe
  Jg @JumpTo7
   Mov eax,Sprite.Hoehe
   Mov B_SpriteBorder,eax
   Jmp @JumpTo8
  @JumpTo7:
   Mov eax,Dest.Hoehe
   Sub eax,y
   Mov B_SpriteBorder,eax
  @JumpTo8:

  Mov eax,R_SpriteBorder           { Gre der Scanline berechnen }
  Sub eax,L_SpriteBorder
  Mov ScanLine,eax

  Mov eax,B_SpriteBorder           { Anzahl der Scanlines berechnen }
  Sub eax,U_SpriteBorder
  Mov ScanLines,eax

  Shl L_SpriteBorder,1             { An 16 Bit anpassen }
  Shl L_DestBorder,1

  Mov esi,Sprite.VWOffset             { Offset im Sprite bestimmen (Quelle) }
  Mov eax,U_SpriteBorder
  Mul Sprite.ByteBreite
  Add eax,L_SpriteBorder
  Add esi,eax

  Mov edi,Dest.VWOffset               { Offset im Speicher bestimmen (Ziel) }
  Mov eax,U_DestBorder
  Mul Dest.ByteBreite
  Add eax,L_DestBorder
  Add edi,eax

  Mov bbb,edi                      { Startoffsets in xxx und ebx festhalten }
  Mov xxx,esi

  @SCANLINES_LOOP:

    Mov ecx,ScanLine
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }

     Mov dx,ax
     Shr ax,3
     Mov sr,ah
     Shr al,2
     Mov sg,al
     And dl,00011111b
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }

     Mov dx,bx
     Shr bx,3               {  rot in ah }
     Shr bl,2               { grn in bl }
     And dl,00011111b       { blau in dl }

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Shr bh,1
     Shr bl,1
     Shr dl,1

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov eax,Dest.ByteBreite
    Add bbb,eax
    Mov edi,bbb

    Mov  edx,Sprite.ByteBreite
    Add  xxx,edx
    Mov  esi,xxx

  Dec ScanLines
  JNZ @SCANLINES_LOOP

  @ENDE:
 End;
End;




PROCEDURE PutMixedHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);
VAR       sr,sg,sb       : Byte;
          bbb            : LongInt;
Begin
 Asm
  Mov eax,Dest.ByteBreite              { Destination Offset bestimmen }
  Mul y
  Shl x,1
  Add eax,x
  Add eax,Dest.VWOffset
  Mov edi,eax
  Mov bbb,eax

  Mov esi,Sprite.VWOffset             { Sprite Offset in esi }

  @SCANLINES_LOOP:

    Mov ecx,Sprite.Breite
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }
     Cmp ax,HideColor
     Je @FarbeNichtSetzen

     Mov dx,ax
     Shr ax,3
     Mov sr,ah
     Shr al,2
     Mov sg,al
     And dl,00011111b
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }

     Mov dx,bx
     Shr bx,3               {  rot in ah }
     Shr bl,2               { grn in bl }
     And dl,00011111b       { blau in dl }

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Shr bh,1
     Shr bl,1
     Shr dl,1

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax
     @FarbeNichtSetzen:

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov eax,Dest.ByteBreite
    Add bbb,eax
    Mov edi,bbb

  Dec Sprite.Hoehe
  JNZ @SCANLINES_LOOP
 END;
End;




PROCEDURE PutMixedClippedHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);
VAR       L_SpriteBorder : LongInt;
          R_SpriteBorder : LongInt;
          U_SpriteBorder : LongInt;
          B_SpriteBorder : LongInt;
          L_DestBorder   : LongInt;
          U_DestBorder   : LongInt;
          ScanLine       : LongInt;
          ScanLines      : LongInt;
          xxx,bbb        : LongInt;
          sr,sg,sb       : Byte;
Begin
 Asm
  Mov eax,x
  Cmp eax,Dest.Breite
  Jge @Ende
  Add eax,Sprite.Breite
  Cmp eax,1
  Jl  @Ende

  Mov ebx,y
  Cmp ebx,Dest.Hoehe
  Jge @Ende
  Add ebx,Sprite.Hoehe
  Cmp ebx,1
  Jl  @Ende

  Push ebx                         { y + Sprite.Hoehe  sichern }
  Push eax                         { x + Sprite.Breite sichern }

  Mov eax,x
  Cmp eax,0
  Jge @JumpTo1
   Neg eax
   Mov L_SpriteBorder,eax
   Mov L_DestBorder,0
   Jmp @JumpTo2
  @JumpTo1:
   Mov L_SpriteBorder,0
   Mov L_DestBorder,eax
  @JumpTo2:

  Mov eax,y
  Cmp eax,0
  Jge @JumpTo3
   Neg eax
   Mov U_SpriteBorder,eax
   Mov U_DestBorder,0
   Jmp @JumpTo4
  @JumpTo3:
   Mov U_SpriteBorder,0
   Mov U_DestBorder,eax
  @JumpTo4:

  Pop eax
  Cmp eax,Dest.Breite
  Jg @JumpTo5
   Mov eax,Sprite.Breite
   Mov R_SpriteBorder,eax
   Jmp @JumpTo6
  @JumpTo5:
   Mov eax,Dest.Breite
   Sub eax,x
   Mov R_SpriteBorder,eax
  @JumpTo6:

  Pop eax
  Cmp eax,Dest.Hoehe
  Jg @JumpTo7
   Mov eax,Sprite.Hoehe
   Mov B_SpriteBorder,eax
   Jmp @JumpTo8
  @JumpTo7:
   Mov eax,Dest.Hoehe
   Sub eax,y
   Mov B_SpriteBorder,eax
  @JumpTo8:

  Mov eax,R_SpriteBorder           { Gre der Scanline berechnen }
  Sub eax,L_SpriteBorder
  Mov ScanLine,eax

  Mov eax,B_SpriteBorder           { Anzahl der Scanlines berechnen }
  Sub eax,U_SpriteBorder
  Mov ScanLines,eax

  Shl L_SpriteBorder,1             { An 16 Bit anpassen }
  Shl L_DestBorder,1

  Mov esi,Sprite.VWOffset             { Offset im Sprite bestimmen (Quelle) }
  Mov eax,U_SpriteBorder
  Mul Sprite.ByteBreite
  Add eax,L_SpriteBorder
  Add esi,eax

  Mov edi,Dest.VWOffset               { Offset im Speicher bestimmen (Ziel) }
  Mov eax,U_DestBorder
  Mul Dest.ByteBreite
  Add eax,L_DestBorder
  Add edi,eax

  Mov bbb,edi
  Mov xxx,esi

  @SCANLINES_LOOP:

    Mov ecx,ScanLine
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }
     Cmp ax,HideColor
     Je @FarbeNichtSetzen

     Mov dx,ax
     Shr ax,3
     Mov sr,ah
     Shr al,2
     Mov sg,al
     And dl,00011111b
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }

     Mov dx,bx
     Shr bx,3               {  rot in ah }
     Shr bl,2               { grn in bl }
     And dl,00011111b       { blau in dl }

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Shr bh,1
     Shr bl,1
     Shr dl,1

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax

     @FarbeNichtSetzen:

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov  eax,Dest.ByteBreite
    Add  bbb,eax
    Mov  edi,bbb

    Mov  edx,Sprite.ByteBreite
    Add  xxx,edx
    Mov  esi,xxx

  Dec ScanLines                    { Scanline-Counter runter zhlen }
  JNZ @SCANLINES_LOOP

  @ENDE:
 End;
End;




PROCEDURE PutTransSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rLight,gLight,bLight:Byte);
VAR       sr,sg,sb       : Byte;
          bbb            : LongInt;
Begin
 Asm
  Mov  eax,Dest.ByteBreite         { Destination Offset bestimmen }
  Mul  y
  Shl  x,1
  Add  eax,x
  Add  eax,Dest.VWOffset
  Mov  edi,eax
  Mov  bbb,eax                     { Und in ebx festhalten }

  Mov  esi,Sprite.VWOffset            { Sprite Offset in esi }

  @SCANLINES_LOOP:

    Mov ecx,Sprite.Breite
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }

     Mov dx,ax
     Shr ax,3
     Mov sr,ah
     Shr al,2
     Mov sg,al
     And dl,00011111b
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }

     Mov dx,bx
     Shr bx,3               {  rot in bh }
     Shr bl,2               { grn in bl }
     And dl,00011111b       { blau in dl }

     Sub bh,rLight
     Cmp bh,0
     Jge @Jump1
      Xor bh,bh
     @Jump1:
     Sub bl,gLight
     Cmp bl,0
     Jge @Jump2
      Xor bl,bl
     @Jump2:
     Sub dl,bLight
     Cmp dl,0
     Jge @Jump3
      Xor dl,dl
     @Jump3:

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Cmp bh,32
     Jb @NoChange1
      Mov bh,31
     @NoChange1:
     Cmp bl,64
     Jb @NoChange2
      Mov bl,63
     @NoChange2:
     Cmp dl,32
     Jb @NoChange3
      Mov dl,31
     @NoChange3:

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov eax,Dest.ByteBreite
    Add bbb,eax
    Mov edi,bbb

  Dec Sprite.Hoehe
  JNZ @SCANLINES_LOOP
 END;
End;




PROCEDURE PutTransClippedSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rLight,gLight,bLight:Byte);
VAR       L_SpriteBorder : LongInt;
          R_SpriteBorder : LongInt;
          U_SpriteBorder : LongInt;
          B_SpriteBorder : LongInt;
          L_DestBorder   : LongInt;
          U_DestBorder   : LongInt;
          ScanLine       : LongInt;
          ScanLines      : LongInt;
          xxx,bbb        : LongInt;
          sr,sg,sb       : Byte;
Begin
 Asm
  Mov eax,x
  Cmp eax,Dest.Breite
  Jge @Ende
  Add eax,Sprite.Breite
  Cmp eax,1
  Jl  @Ende

  Mov ebx,y
  Cmp ebx,Dest.Hoehe
  Jge @Ende
  Add ebx,Sprite.Hoehe
  Cmp ebx,1
  Jl  @Ende

  Push ebx                         { y + Sprite.Hoehe  sichern }
  Push eax                         { x + Sprite.Breite sichern }

  Mov eax,x
  Cmp eax,0
  Jge @JumpTo1
   Neg eax
   Mov L_SpriteBorder,eax
   Mov L_DestBorder,0
   Jmp @JumpTo2
  @JumpTo1:
   Mov L_SpriteBorder,0
   Mov L_DestBorder,eax
  @JumpTo2:

  Mov eax,y
  Cmp eax,0
  Jge @JumpTo3
   Neg eax
   Mov U_SpriteBorder,eax
   Mov U_DestBorder,0
   Jmp @JumpTo4
  @JumpTo3:
   Mov U_SpriteBorder,0
   Mov U_DestBorder,eax
  @JumpTo4:

  Pop eax
  Cmp eax,Dest.Breite
  Jg @JumpTo5
   Mov eax,Sprite.Breite
   Mov R_SpriteBorder,eax
   Jmp @JumpTo6
  @JumpTo5:
   Mov eax,Dest.Breite
   Sub eax,x
   Mov R_SpriteBorder,eax
  @JumpTo6:

  Pop eax
  Cmp eax,Dest.Hoehe
  Jg @JumpTo7
   Mov eax,Sprite.Hoehe
   Mov B_SpriteBorder,eax
   Jmp @JumpTo8
  @JumpTo7:
   Mov eax,Dest.Hoehe
   Sub eax,y
   Mov B_SpriteBorder,eax
  @JumpTo8:

  Mov eax,R_SpriteBorder           { Gre der Scanline berechnen }
  Sub eax,L_SpriteBorder
  Mov ScanLine,eax

  Mov eax,B_SpriteBorder           { Anzahl der Scanlines berechnen }
  Sub eax,U_SpriteBorder
  Mov ScanLines,eax

  Shl L_SpriteBorder,1             { An 16 Bit anpassen }
  Shl L_DestBorder,1

  Mov esi,Sprite.VWOffset             { Offset im Sprite bestimmen (Quelle) }
  Mov eax,U_SpriteBorder
  Mul Sprite.ByteBreite
  Add eax,L_SpriteBorder
  Add esi,eax

  Mov edi,Dest.VWOffset               { Offset im Speicher bestimmen (Ziel) }
  Mov eax,U_DestBorder
  Mul Dest.ByteBreite
  Add eax,L_DestBorder
  Add edi,eax

  Mov bbb,edi                      { Startoffsets in xxx und ebx festhalten }
  Mov xxx,esi

  @SCANLINES_LOOP:

    Mov ecx,ScanLine
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }

     Mov dx,ax
     Shr ax,3
     Mov sr,ah
     Shr al,2
     Mov sg,al
     And dl,00011111b
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }

     Mov dx,bx
     Shr bx,3               {  rot in ah }
     Shr bl,2               { grn in bl }
     And dl,00011111b       { blau in dl }

     Sub bh,rLight
     Cmp bh,0
     Jge @Jump1
      Xor bh,bh
     @Jump1:
     Sub bl,gLight
     Cmp bl,0
     Jge @Jump2
      Xor bl,bl
     @Jump2:
     Sub dl,bLight
     Cmp dl,0
     Jge @Jump3
      Xor dl,dl
     @Jump3:

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Cmp bh,32
     Jb @NoChange1
      Mov bh,31
     @NoChange1:
     Cmp bl,64
     Jb @NoChange2
      Mov bl,63
     @NoChange2:
     Cmp dl,32
     Jb @NoChange3
      Mov dl,31
     @NoChange3:

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov eax,Dest.ByteBreite
    Add bbb,eax
    Mov edi,bbb

    Mov  edx,Sprite.ByteBreite
    Add  xxx,edx
    Mov  esi,xxx

  Dec ScanLines
  JNZ @SCANLINES_LOOP

  @ENDE:
 End;
End;




PROCEDURE PutTransHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rLight,gLight,bLight:Byte;HideColor:Word);
VAR       sr,sg,sb  : Byte;
          bbb       : LongInt;
Begin
 Asm
  Mov eax,Dest.ByteBreite              { Destination Offset bestimmen }
  Mul y
  Shl x,1
  Add eax,x
  Add eax,Dest.VWOffset
  Mov edi,eax
  Mov bbb,eax

  Mov esi,Sprite.VWOffset             { Sprite Offset in esi }

  @SCANLINES_LOOP:

    Mov ecx,Sprite.Breite
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }
     Cmp ax,HideColor
     Je @FarbeNichtSetzen

     Mov dx,ax
     Shr ax,3
     Mov sr,ah
     Shr al,2
     Mov sg,al
     And dl,00011111b
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }

     Mov dx,bx
     Shr bx,3               {  rot in ah }
     Shr bl,2               { grn in bl }
     And dl,00011111b       { blau in dl }

     Sub bh,rLight
     Cmp bh,0
     Jge @Jump1
      Xor bh,bh
     @Jump1:
     Sub bl,gLight
     Cmp bl,0
     Jge @Jump2
      Xor bl,bl
     @Jump2:
     Sub dl,bLight
     Cmp dl,0
     Jge @Jump3
      Xor dl,dl
     @Jump3:

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Cmp bh,32
     Jb @NoChange1
      Mov bh,31
     @NoChange1:
     Cmp bl,64
     Jb @NoChange2
      Mov bl,63
     @NoChange2:
     Cmp dl,32
     Jb @NoChange3
      Mov dl,31
     @NoChange3:

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax
     @FarbeNichtSetzen:

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov eax,Dest.ByteBreite
    Add bbb,eax
    Mov edi,bbb

  Dec Sprite.Hoehe
  JNZ @SCANLINES_LOOP
 END;
End;




PROCEDURE PutTransClippedHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;rLight,gLight,bLight:Byte;HideColor:Word);
VAR       L_SpriteBorder : LongInt;
          R_SpriteBorder : LongInt;
          U_SpriteBorder : LongInt;
          B_SpriteBorder : LongInt;
          L_DestBorder   : LongInt;
          U_DestBorder   : LongInt;
          ScanLine       : LongInt;
          ScanLines      : LongInt;
          xxx,bbb        : LongInt;
          sr,sg,sb       : Byte;
Begin
 Asm
  Mov eax,x
  Cmp eax,Dest.Breite
  Jge @Ende
  Add eax,Sprite.Breite
  Cmp eax,1
  Jl  @Ende

  Mov ebx,y
  Cmp ebx,Dest.Hoehe
  Jge @Ende
  Add ebx,Sprite.Hoehe
  Cmp ebx,1
  Jl  @Ende

  Push ebx                         { y + Sprite.Hoehe  sichern }
  Push eax                         { x + Sprite.Breite sichern }

  Mov eax,x
  Cmp eax,0
  Jge @JumpTo1
   Neg eax
   Mov L_SpriteBorder,eax
   Mov L_DestBorder,0
   Jmp @JumpTo2
  @JumpTo1:
   Mov L_SpriteBorder,0
   Mov L_DestBorder,eax
  @JumpTo2:

  Mov eax,y
  Cmp eax,0
  Jge @JumpTo3
   Neg eax
   Mov U_SpriteBorder,eax
   Mov U_DestBorder,0
   Jmp @JumpTo4
  @JumpTo3:
   Mov U_SpriteBorder,0
   Mov U_DestBorder,eax
  @JumpTo4:

  Pop eax
  Cmp eax,Dest.Breite
  Jg @JumpTo5
   Mov eax,Sprite.Breite
   Mov R_SpriteBorder,eax
   Jmp @JumpTo6
  @JumpTo5:
   Mov eax,Dest.Breite
   Sub eax,x
   Mov R_SpriteBorder,eax
  @JumpTo6:

  Pop eax
  Cmp eax,Dest.Hoehe
  Jg @JumpTo7
   Mov eax,Sprite.Hoehe
   Mov B_SpriteBorder,eax
   Jmp @JumpTo8
  @JumpTo7:
   Mov eax,Dest.Hoehe
   Sub eax,y
   Mov B_SpriteBorder,eax
  @JumpTo8:

  Mov eax,R_SpriteBorder           { Gre der Scanline berechnen }
  Sub eax,L_SpriteBorder
  Mov ScanLine,eax

  Mov eax,B_SpriteBorder           { Anzahl der Scanlines berechnen }
  Sub eax,U_SpriteBorder
  Mov ScanLines,eax

  Shl L_SpriteBorder,1             { An 16 Bit anpassen }
  Shl L_DestBorder,1

  Mov esi,Sprite.VWOffset             { Offset im Sprite bestimmen (Quelle) }
  Mov eax,U_SpriteBorder
  Mul Sprite.ByteBreite
  Add eax,L_SpriteBorder
  Add esi,eax

  Mov edi,Dest.VWOffset               { Offset im Speicher bestimmen (Ziel) }
  Mov eax,U_DestBorder
  Mul Dest.ByteBreite
  Add eax,L_DestBorder
  Add edi,eax

  Mov bbb,edi
  Mov xxx,esi

  @SCANLINES_LOOP:

    Mov ecx,ScanLine
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }
     Cmp ax,HideColor
     Je @FarbeNichtSetzen

     Mov dx,ax
     Shr ax,3
     Mov sr,ah
     Shr al,2
     Mov sg,al
     And dl,00011111b
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }

     Mov dx,bx
     Shr bx,3               {  rot in ah }
     Shr bl,2               { grn in bl }
     And dl,00011111b       { blau in dl }

     Sub bh,rLight
     Cmp bh,0
     Jge @Jump1
      Xor bh,bh
     @Jump1:
     Sub bl,gLight
     Cmp bl,0
     Jge @Jump2
      Xor bl,bl
     @Jump2:
     Sub dl,bLight
     Cmp dl,0
     Jge @Jump3
      Xor dl,dl
     @Jump3:

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Cmp bh,32
     Jb @NoChange1
      Mov bh,31
     @NoChange1:
     Cmp bl,64
     Jb @NoChange2
      Mov bl,63
     @NoChange2:
     Cmp dl,32
     Jb @NoChange3
      Mov dl,31
     @NoChange3:

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax

     @FarbeNichtSetzen:

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov  eax,Dest.ByteBreite
    Add  bbb,eax
    Mov  edi,bbb

    Mov  edx,Sprite.ByteBreite
    Add  xxx,edx
    Mov  esi,xxx

  Dec ScanLines                    { Scanline-Counter runter zhlen }
  JNZ @SCANLINES_LOOP

  @ENDE:
 End;
End;




PROCEDURE PutAlphaSprite(Dest,Sprite:VirtualWindow;x,y:LongInt);
VAR       sr,sg,sb : Byte;
          bbb      : LongInt;
Begin
 Asm
  Mov  eax,Dest.Breite             { Destination Offset bestimmen }
  Mul  y
  Add  eax,x
  Shl  eax,1
  Add  eax,Dest.VWOffset
  Mov  edi,eax
  Mov  bbb,eax

  Mov  esi,Sprite.VWOffset            { Sprite Offset in esi }

  @SCANLINES_LOOP:

    Mov ecx,Sprite.Breite
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }

     Mov dx,ax
     Shr ax,3
     Mov sr,ah
     Shr al,2
     Mov sg,al
     And dl,00011111b
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }
     Mov dx,bx

     Shr bx,3                      { Rot in bh }
     Shr bl,2                      { Grn in bl }
     And dl,00011111b              { Blau in dl }

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Cmp bh,32
     Jb @NoChange1
      Mov bh,31
     @NoChange1:
     Cmp bl,64
     Jb @NoChange2
      Mov bl,63
     @NoChange2:
     Cmp dl,32
     Jb @NoChange3
      Mov dl,31
     @NoChange3:

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov eax,Dest.ByteBreite
    Add bbb,eax
    Mov edi,bbb

  Dec Sprite.Hoehe
  JNZ @SCANLINES_LOOP
 END;
End;




PROCEDURE PutAlphaClippedSprite(Dest,Sprite:VirtualWindow;x,y:LongInt);
VAR       L_SpriteBorder : LongInt;
          R_SpriteBorder : LongInt;
          U_SpriteBorder : LongInt;
          B_SpriteBorder : LongInt;
          L_DestBorder   : LongInt;
          U_DestBorder   : LongInt;
          ScanLine       : LongInt;
          ScanLines      : LongInt;
          xxx,bbb        : LongInt;
          sr,sg,sb       : Byte;
Begin
 Asm
  Mov eax,x
  Cmp eax,Dest.Breite
  Jge @Ende
  Add eax,Sprite.Breite
  Cmp eax,1
  Jl  @Ende

  Mov ebx,y
  Cmp ebx,Dest.Hoehe
  Jge @Ende
  Add ebx,Sprite.Hoehe
  Cmp ebx,1
  Jl  @Ende

  Push ebx                         { y + Sprite.Hoehe  sichern }
  Push eax                         { x + Sprite.Breite sichern }

  Mov eax,x
  Cmp eax,0
  Jge @JumpTo1
   Neg eax
   Mov L_SpriteBorder,eax
   Mov L_DestBorder,0
   Jmp @JumpTo2
  @JumpTo1:
   Mov L_SpriteBorder,0
   Mov L_DestBorder,eax
  @JumpTo2:

  Mov eax,y
  Cmp eax,0
  Jge @JumpTo3
   Neg eax
   Mov U_SpriteBorder,eax
   Mov U_DestBorder,0
   Jmp @JumpTo4
  @JumpTo3:
   Mov U_SpriteBorder,0
   Mov U_DestBorder,eax
  @JumpTo4:

  Pop eax
  Cmp eax,Dest.Breite
  Jg @JumpTo5
   Mov eax,Sprite.Breite
   Mov R_SpriteBorder,eax
   Jmp @JumpTo6
  @JumpTo5:
   Mov eax,Dest.Breite
   Sub eax,x
   Mov R_SpriteBorder,eax
  @JumpTo6:

  Pop eax
  Cmp eax,Dest.Hoehe
  Jg @JumpTo7
   Mov eax,Sprite.Hoehe
   Mov B_SpriteBorder,eax
   Jmp @JumpTo8
  @JumpTo7:
   Mov eax,Dest.Hoehe
   Sub eax,y
   Mov B_SpriteBorder,eax
  @JumpTo8:

  Mov eax,R_SpriteBorder           { Gre der Scanline berechnen }
  Sub eax,L_SpriteBorder
  Mov ScanLine,eax

  Mov eax,B_SpriteBorder           { Anzahl der Scanlines berechnen }
  Sub eax,U_SpriteBorder
  Mov ScanLines,eax

  Shl L_SpriteBorder,1             { An 16 Bit anpassen }
  Shl L_DestBorder,1

  Mov esi,Sprite.VWOffset             { Offset im Sprite bestimmen (Quelle) }
  Mov eax,U_SpriteBorder
  Mul Sprite.ByteBreite
  Add eax,L_SpriteBorder
  Add esi,eax

  Mov edi,Dest.VWOffset               { Offset im Speicher bestimmen (Ziel) }
  Mov eax,U_DestBorder
  Mul Dest.ByteBreite
  Add eax,L_DestBorder
  Add edi,eax

  Mov bbb,edi
  Mov xxx,esi

  @SCANLINES_LOOP:

    Mov ecx,ScanLine
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }

     Mov dx,ax
     Shr ax,3
     Mov sr,ah
     Shr al,2
     Mov sg,al
     And dl,00011111b
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }
     Mov dx,bx

     Shr bx,3                      { Rot in bh }
     Shr bl,2                      { Grn in bl }
     And dl,00011111b              { Blau in dl }

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Cmp bh,32
     Jb @NoChange1
      Mov bh,31
     @NoChange1:
     Cmp bl,64
     Jb @NoChange2
      Mov bl,63
     @NoChange2:
     Cmp dl,32
     Jb @NoChange3
      Mov dl,31
     @NoChange3:

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov eax,Dest.ByteBreite
    Add bbb,eax
    Mov edi,bbb

    Mov  edx,Sprite.ByteBreite
    Add  xxx,edx
    Mov  esi,xxx

  Dec ScanLines
  JNZ @SCANLINES_LOOP

  @ENDE:
 End;
End;




PROCEDURE PutAlphaHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);
VAR       sr,sg,sb : Byte;
          bbb      : LongInt;
Begin
 Asm
  Mov eax,Dest.Breite              { Destination Offset bestimmen }
  Mul y
  Add eax,x
  Shl eax,1
  Add eax,Dest.VWOffset
  Mov edi,eax
  Mov bbb,eax

  Mov esi,Sprite.VWOffset             { Sprite Offset in esi }

  @SCANLINES_LOOP:

    Mov ecx,Sprite.Breite
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }
     Cmp ax,HideColor
     Je @FarbeNichtSetzen

     Mov dx,ax
     Shr ax,3
     Mov sr,ah
     Shr al,2
     Mov sg,al
     And dl,00011111b
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }
     Mov dx,bx

     Shr bx,3                      { Rot in bh }
     Shr bl,2                      { Grn in bl }
     And dl,00011111b              { Blau in dl }

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Cmp bh,32
     Jb @NoChange1
      Mov bh,31
     @NoChange1:
     Cmp bl,64
     Jb @NoChange2
      Mov bl,63
     @NoChange2:
     Cmp dl,32
     Jb @NoChange3
      Mov dl,31
     @NoChange3:

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax
     @FarbeNichtSetzen:

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov eax,Dest.ByteBreite
    Add bbb,eax
    Mov edi,bbb

  Dec Sprite.Hoehe
  JNZ @SCANLINES_LOOP
 END;
End;




PROCEDURE PutAlphaClippedHCSprite(Dest,Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);
VAR       L_SpriteBorder : LongInt;
          R_SpriteBorder : LongInt;
          U_SpriteBorder : LongInt;
          B_SpriteBorder : LongInt;
          L_DestBorder   : LongInt;
          U_DestBorder   : LongInt;
          ScanLine       : LongInt;
          ScanLines      : LongInt;
          xxx,bbb        : LongInt;
          sr,sg,sb       : Byte;
Begin
 Asm
  Mov eax,x
  Cmp eax,Dest.Breite
  Jge @Ende
  Add eax,Sprite.Breite
  Cmp eax,1
  Jl  @Ende

  Mov ebx,y
  Cmp ebx,Dest.Hoehe
  Jge @Ende
  Add ebx,Sprite.Hoehe
  Cmp ebx,1
  Jl  @Ende

  Push ebx                         { y + Sprite.Hoehe  sichern }
  Push eax                         { x + Sprite.Breite sichern }

  Mov eax,x
  Cmp eax,0
  Jge @JumpTo1
   Neg eax
   Mov L_SpriteBorder,eax
   Mov L_DestBorder,0
   Jmp @JumpTo2
  @JumpTo1:
   Mov L_SpriteBorder,0
   Mov L_DestBorder,eax
  @JumpTo2:

  Mov eax,y
  Cmp eax,0
  Jge @JumpTo3
   Neg eax
   Mov U_SpriteBorder,eax
   Mov U_DestBorder,0
   Jmp @JumpTo4
  @JumpTo3:
   Mov U_SpriteBorder,0
   Mov U_DestBorder,eax
  @JumpTo4:

  Pop eax
  Cmp eax,Dest.Breite
  Jg @JumpTo5
   Mov eax,Sprite.Breite
   Mov R_SpriteBorder,eax
   Jmp @JumpTo6
  @JumpTo5:
   Mov eax,Dest.Breite
   Sub eax,x
   Mov R_SpriteBorder,eax
  @JumpTo6:

  Pop eax
  Cmp eax,Dest.Hoehe
  Jg @JumpTo7
   Mov eax,Sprite.Hoehe
   Mov B_SpriteBorder,eax
   Jmp @JumpTo8
  @JumpTo7:
   Mov eax,Dest.Hoehe
   Sub eax,y
   Mov B_SpriteBorder,eax
  @JumpTo8:

  Mov eax,R_SpriteBorder           { Gre der Scanline berechnen }
  Sub eax,L_SpriteBorder
  Mov ScanLine,eax

  Mov eax,B_SpriteBorder           { Anzahl der Scanlines berechnen }
  Sub eax,U_SpriteBorder
  Mov ScanLines,eax

  Shl L_SpriteBorder,1             { An 16 Bit anpassen }
  Shl L_DestBorder,1

  Mov esi,Sprite.VWOffset             { Offset im Sprite bestimmen (Quelle) }
  Mov eax,U_SpriteBorder
  Mul Sprite.ByteBreite
  Add eax,L_SpriteBorder
  Add esi,eax

  Mov edi,Dest.VWOffset               { Offset im Speicher bestimmen (Ziel) }
  Mov eax,U_DestBorder
  Mul Dest.ByteBreite
  Add eax,L_DestBorder
  Add edi,eax

  Mov bbb,edi
  Mov xxx,esi

  @SCANLINES_LOOP:

    Mov ecx,ScanLine
    @SCANLINE_LOOP:

     Mov ax,[esi]                  { Load Sprite r,g,b }
     Cmp ax,HideColor
     Je @FarbeNichtSetzen

     Mov dx,ax
     Shr ax,3
     Mov sr,ah
     Shr al,2
     Mov sg,al
     And dl,00011111b
     Mov sb,dl

     Mov bx,[edi]               { Load Destination r,g,b }

     Mov dx,bx
     Shr bx,3                      { Rot in bh }
     Shr bl,2                      { Grn in bl }
     And dl,00011111b              { Blau in dl }

     Add bh,sr
     Add bl,sg
     Add dl,sb

     Cmp bh,32
     Jb @NoChange1
      Mov bh,31
     @NoChange1:
     Cmp bl,64
     Jb @NoChange2
      Mov bl,63
     @NoChange2:
     Cmp dl,32
     Jb @NoChange3
      Mov dl,31
     @NoChange3:

     Mov al,bh
     Shl ax,6
     Add al,bl
     Shl ax,5
     Add al,dl

     Mov [edi],ax

     @FarbeNichtSetzen:

     Add esi,2
     Add edi,2

    Dec ecx
    JNZ @SCANLINE_LOOP

    Mov  eax,Dest.ByteBreite
    Add  bbb,eax
    Mov  edi,bbb

    Mov  edx,Sprite.ByteBreite
    Add  xxx,edx
    Mov  esi,xxx

  Dec ScanLines                    { Scanline-Counter runter zhlen }
  JNZ @SCANLINES_LOOP

 @ENDE:
 End;
End;



{ Sprites have to be of same size !!! }
PROCEDURE FadeSprite(Source,Dest:VirtualWindow); Assembler;
VAR       sr,sg,sb : Byte;
Asm
 Mov esi,Source
 Mov esi,[esi]

 Mov edi,dest
 Mov ecx,[edi+4]
 Mov eax,[edi  ]
 Mov edi,eax
 Shr ecx,1

 @REPEATS:

    Mov ax,[edi]               { Load Destination r,g,b }

    Mov dx,ax
    Shr ax,3
    Shr al,2
    And dl,00011111b
    Mov sr,ah
    Mov sg,al
    Mov sb,dl

    Mov ax,[esi]                  { Load Source r,g,b }

    Mov dx,ax
    Shr ax,3
    Shr al,2
    And dl,00011111b

    Cmp ah,sr                     { Fading... }
    Jae @JumpIt1
     Inc ah
    @JumpIt1:
    Jbe @JumpIt2
     Dec ah
    @JumpIt2:

    Cmp al,sg
    Jge @JumpIt3
     Add al,2
     Cmp al,sg
     Jle @JumpIt3
      Dec al
    @JumpIt3:
    Cmp al,sg
    Jle @JumpIt4
     Sub al,2
     Cmp al,sg
     Jge @JumpIt4
      Inc al
    @JumpIt4:

    Cmp dl,sb
    Jae @JumpIt5
     Inc dl
    @JumpIt5:
    Jbe @JumpIt6
     Dec dl
    @JumpIt6:

    Shl al,2
    Shl ax,3
    Add al,dl

    Mov [esi],ax

    Add esi,2
    Add edi,2

 Dec ecx
 JNZ @REPEATS
End;




{ Sprites have to be of same size !!! }
PROCEDURE FadeSpriteVar(Source,Dest:VirtualWindow;r,g,b:Byte); Assembler;
VAR       sr,sg,sb : Byte;
Asm
 Mov esi,Source
 Mov esi,[esi]

 Mov edi,dest
 Mov ecx,[edi+4]
 Mov eax,[edi  ]
 Shr ecx,1
 Mov edi,eax

 @REPEATS:

    Mov ax,[edi]               { Load Destination r,g,b }

    Mov dx,ax
    Shr ax,3
    Mov sr,ah
    Shr al,2
    Mov sg,al
    And dl,00011111b
    Mov sb,dl

    Mov ax,[esi]                  { Load Source r,g,b }

    Mov dx,ax
    Shr ax,3
    Shr al,2
    And dl,00011111b

    Cmp ah,sr                     { Fading... }
    Jge @JumpIt1
     Add ah,r
     Cmp ah,sr
     Jle @JumpIt1
      Mov ah,sr
    @JumpIt1:
    Cmp ah,sr
    Jle @JumpIt2
     Sub ah,r
     Cmp ah,sr
     Jge @JumpIt2
      Mov ah,sr
    @JumpIt2:

    Cmp al,sg
    Jge @JumpIt3
     Add al,g
     Cmp al,sg
     Jle @JumpIt3
      Mov al,sg
    @JumpIt3:
    Cmp al,sg
    Jle @JumpIt4
     Sub al,g
     Cmp al,sg
     Jge @JumpIt4
      Mov al,sg
    @JumpIt4:

    Cmp dl,sb
    Jge @JumpIt5
     Add dl,b
     Cmp dl,sb
     Jle @JumpIt5
      Mov dl,sb
    @JumpIt5:
    Cmp dl,sb
    Jle @JumpIt6
     Sub dl,b
     Cmp dl,sb
     Jge @JumpIt6
      Mov dl,sb
    @JumpIt6:

    Shl al,2
    Shl ax,3
    Add al,dl

    Mov [esi],ax

    Add esi,2
    Add edi,2

 Dec ecx
 JNZ @REPEATS
End;




PROCEDURE ScaleSprite(SourSprite,DestSprite:VirtualWindow);
VAR      xGanz      : LongInt;
         yGanz      : LongInt;
         Hoehe      : LongInt;
         xRest      : Word;
         yRest      : Word;
         xRestTemp  : Word;
         yRestTemp  : Word;
         Temp       : Real;
Begin
 Temp := SourSprite.Breite / DestSprite.Breite;
 xRest:= Trunc(Frac(Temp)*65535);
 xGanz:= Trunc(Temp);

 Temp := SourSprite.Hoehe / DestSprite.Hoehe;
 yRest:= Trunc(Frac(Temp)*65535);
 yGanz:= Trunc(Temp);

 Asm
  Push es
  Mov  ax,ds
  Mov  es,ax
  Mov  edi,DestSprite.VWOffset
  Mov  esi,SourSprite.VWOffset

  Mov  eax,Destsprite.Hoehe
  Mov  Hoehe,eax

  Xor  ecx,ecx
  Shl  xGanz,1
  Mov  yRestTemp,0

  Mov ebx,DestSprite.Breite

  @Y_LOOP:

     Xor dx,dx
     Mov ebx,DestSprite.Breite
     @X_LOOP:

       MovsW

       Add esi,xGanz
       Add dx,xRest
       Jc @Jump
        Sub esi,2
       @Jump:

     Dec ebx
     JNZ @X_LOOP

     Add ecx,yGanz
     Mov ax,yRest
     Add yRestTemp,ax
     Jnc @NoInc2
      Inc ecx
     @NoInc2:

     Mov esi,SourSprite.VWOffset
     Mov eax,ecx
     Mul SourSprite.ByteBreite
     Add esi,eax

  Dec Hoehe
  JNZ @Y_LOOP

  Pop es
 End;
End;




PROCEDURE AdjustSpriteBrightness(SourSprite:VirtualWindow;r,g,b:ShortInt); Assembler;
Asm
 Mov esi,SourSprite
 Mov ecx,[esi+4]
 Mov esi,[esi  ]
 Shr ecx,1

 @REPEAT:

  Mov ax,[esi]

  Mov bl,al
  And bl,00011111b    { blau in bl }
  Shr ax,3            {  rot in ah }
  Shr al,2            { grn in al }

  Add ah,r
  Add al,g
  Add bl,b

  Cmp ah,31
  Jle @Jump1
   Mov ah,31
   Jmp @Jump2
  @Jump1:
  Cmp ah,0
  Jge @Jump2
   Xor ah,ah
  @Jump2:

  Cmp al,63
  Jle @Jump3
   Mov al,63
   Jmp @Jump4
  @Jump3:
  Cmp al,0
  Jge @Jump4
   Xor al,al
  @Jump4:

  Cmp bl,31
  Jle @Jump5
   Mov bl,31
   Jmp @Jump6
  @Jump5:
  Cmp bl,0
  Jge @Jump6
   Xor bl,bl
  @Jump6:

  Shl al,2
  Shl ax,3
  Add al,bl

  Mov [esi],ax

  Add esi,2

 LOOP @REPEAT
End;




PROCEDURE AdjustSpriteHCBrightness(SourSprite:VirtualWindow;r,g,b:ShortInt;HideColor:Word); Assembler;
Asm
 Mov esi,SourSprite
 Mov ecx,[esi+4]
 Mov esi,[esi  ]
 Shr ecx,1

 @REPEAT:

  Mov ax,[esi]

  Cmp ax,HideColor
  Je @NoChange

  Mov bl,al
  And bl,00011111b    { blau in bl }
  Shr ax,3            {  rot in ah }
  Shr al,2            { grn in al }

  Add ah,r
  Add al,g
  Add bl,b

  Cmp ah,31
  Jle @Jump1
   Mov ah,31
   Jmp @Jump2
  @Jump1:
  Cmp ah,0
  Jge @Jump2
   Xor ah,ah
  @Jump2:

  Cmp al,63
  Jle @Jump3
   Mov al,63
   Jmp @Jump4
  @Jump3:
  Cmp al,0
  Jge @Jump4
   Xor al,al
  @Jump4:

  Cmp bl,31
  Jle @Jump5
   Mov bl,31
   Jmp @Jump6
  @Jump5:
  Cmp bl,0
  Jge @Jump6
   Xor bl,bl
  @Jump6:

  Shl al,2
  Shl ax,3
  Add al,bl

  Mov [esi],ax

  @NoChange:

  Add esi,2

 LOOP @REPEAT
End;




PROCEDURE IncreaseSpriteBrightness(SourSprite:VirtualWindow;r,g,b:Byte); Assembler;
Asm
 Mov esi,SourSprite
 Mov ecx,[esi+4]
 Mov esi,[esi  ]
 Shr ecx,1

 @REPEAT:

  Mov ax,[esi]

  Mov bl,al
  And bl,00011111b    { blau in bl }
  Shr ax,3            {  rot in ah }
  Shr al,2            { grn in al }

  Add ah,r
  Add al,g
  Add bl,b

  Cmp ah,31
  Jle @Jump1
   Mov ah,31
  @Jump1:

  Cmp al,63
  Jle @Jump2
   Mov al,63
  @Jump2:

  Cmp bl,31
  Jle @Jump3
   Mov bl,31
  @Jump3:

  Shl al,2
  Shl ax,3
  Add al,bl

  Mov [esi],ax

  Add esi,2

 LOOP @REPEAT
End;




PROCEDURE IncreaseSpriteHCBrightness(SourSprite:VirtualWindow;r,g,b:Byte;HideColor:Word); Assembler;
Asm
 Mov esi,SourSprite
 Mov ecx,[esi+4]
 Mov esi,[esi  ]
 Shr ecx,1

 @REPEAT:

  Mov ax,[esi]

  Cmp ax,HideColor
  Je @NoChange

  Mov bl,al
  And bl,00011111b    { blau in bl }
  Shr ax,3            {  rot in ah }
  Shr al,2            { grn in al }

  Add ah,r
  Add al,g
  Add bl,b

  Cmp ah,31
  Jle @Jump1
   Mov ah,31
  @Jump1:

  Cmp al,63
  Jle @Jump2
   Mov al,63
  @Jump2:

  Cmp bl,31
  Jle @Jump3
   Mov bl,31
  @Jump3:

  Shl al,2
  Shl ax,3
  Add al,bl

  Mov [esi],ax

  @NoChange:

  Add esi,2

 LOOP @REPEAT
End;




PROCEDURE DecreaseSpriteBrightness(SourSprite:VirtualWindow;r,g,b:Byte); Assembler;
Asm
 Mov esi,SourSprite
 Mov ecx,[esi+4]
 Mov esi,[esi  ]
 Shr ecx,1

 @REPEAT:

  Mov ax,[esi]

  Mov bl,al
  And bl,00011111b    { blau in bl }
  Shr ax,3            {  rot in ah }
  Shr al,2            { grn in al }

  Add ah,r
  Add al,g
  Add bl,b

  Cmp ah,0
  Jge @Jump2
   Xor ah,ah
  @Jump2:

  Cmp al,0
  Jge @Jump4
   Xor al,al
  @Jump4:

  Cmp bl,0
  Jge @Jump6
   Xor bl,bl
  @Jump6:

  Shl al,2
  Shl ax,3
  Add al,bl

  Mov [esi],ax

  Add esi,2

 LOOP @REPEAT
End;





PROCEDURE DecreaseSpriteHCBrightness(SourSprite:VirtualWindow;r,g,b:Byte;HideColor:Word); Assembler;
Asm
 Mov esi,SourSprite
 Mov ecx,[esi+4]
 Mov esi,[esi  ]
 Shr ecx,1

 @REPEAT:

  Mov ax,[esi]

  Cmp ax,HideColor
  Je @NoChange

  Mov bl,al
  And bl,00011111b    { blau in bl }
  Shr ax,3            {  rot in ah }
  Shr al,2            { grn in al }

  Sub ah,r
  Sub al,g
  Sub bl,b

  Cmp ah,0
  Jge @Jump2
   Xor ah,ah
  @Jump2:

  Cmp al,0
  Jge @Jump4
   Xor al,al
  @Jump4:

  Cmp bl,0
  Jge @Jump6
   Xor bl,bl
  @Jump6:

  Shl al,2
  Shl ax,3
  Add al,bl

  Mov [esi],ax

  @NoChange:

  Add esi,2

 LOOP @REPEAT
End;




PROCEDURE CopySprite(Sour,Dest:VirtualWindow); Assembler;
Asm
  Mov esi,Sour
  Mov eax,[esi+4]
  Mov esi,[esi  ]

  Mov edi,Dest
  Mov edi,[edi  ]
  Mov bx,ds
  Mov es,bx

   Xor edx,edx
   Mov ecx,8
   Div ecx
   Mov ecx,eax

   @SCHLEIFE:

    MovQ mm1,[esi];     MovQ [edi],mm1

    Add esi,8
    Add edi,8

   LOOP @SCHLEIFE
   Emms

   Mov ecx,edx
   Rep StosB

End;




PROCEDURE Rotate_Scale_Sprite(Sour,Dest:VirtualWindow;x,y,Breite,Hoehe,Winkel:LongInt);
VAR       RealWert                         : Real;
          yPos,Temp_TLx,Temp_TLy           : LongInt;
          xDIFF,yDIFF,xADD,yADD,Rest       : LongInt;
          Corner_TLx,Corner_TLy            : LongInt;
          Corner_TRx,Corner_TRy            : LongInt;
          Corner_BLx,Corner_BLy            : LongInt;
          Corner_BRx,Corner_BRy            : LongInt;
          Position,Loop                    : LongInt;
          PosGanz_X,PosGanz_Y,NewWinkel    : LongInt;
          PosRest_X,PosRest_Y              : Word;
          RestCounter_X,RestCounter_Y      : Word;

Begin


 { FIRST CALCULATE X/Y CORDS OF THE SPRITE CORNERS }


 RealWert:= Sqrt((Breite shr 1 * Breite shr 1) shl 1);

 NewWinkel:= Winkel +  45;
 If NewWinkel<  0 then NewWinkel:= NewWinkel +  (Abs(NewWinkel div 360)+1) * 360;
 If NewWinkel>360 then NewWinkel:= NewWinkel -      (NewWinkel div 360)    * 360;
 Corner_TRx:= x + Trunc( Cosin[NewWinkel] * RealWert );
 Corner_TRy:= y - Trunc( Sinus[NewWinkel] * RealWert );

 NewWinkel:= Winkel + 135;
 If NewWinkel<  0 then NewWinkel:= NewWinkel +  (Abs(NewWinkel div 360)+1) * 360;
 If NewWinkel>360 then NewWinkel:= NewWinkel -      (NewWinkel div 360)    * 360;
 Corner_TLx:= x + Trunc( Cosin[NewWinkel] * RealWert );
 Corner_TLy:= y - Trunc( Sinus[NewWinkel] * RealWert );

 NewWinkel:= Winkel + 225;
 If NewWinkel<  0 then NewWinkel:= NewWinkel +  (Abs(NewWinkel div 360)+1) * 360;
 If NewWinkel>360 then NewWinkel:= NewWinkel -      (NewWinkel div 360)    * 360;
 Corner_BLx:= x + Trunc( Cosin[NewWinkel] * RealWert );
 Corner_BLy:= y - Trunc( Sinus[NewWinkel] * RealWert );

 NewWinkel:= Winkel + 315;
 If NewWinkel<  0 then NewWinkel:= NewWinkel +  (Abs(NewWinkel div 360)+1) * 360;
 If NewWinkel>360 then NewWinkel:= NewWinkel -      (NewWinkel div 360)    * 360;
 Corner_BRx:= x + Trunc( Cosin[NewWinkel] * RealWert );
 Corner_BRy:= y - Trunc( Sinus[NewWinkel] * RealWert );


 { NOW PRECALCULATE X/Y POSITIONS IN THE FIRST LINE FOR ALL LINES (SPEED UP) }


  ASM
   Mov eax,Corner_TLx
   Mov Temp_TLx,eax
   Mov eax,Corner_TLy
   Mov Temp_TLy,eax
   Mov Position,0

   Mov eax,Temp_TLx
   Cmp eax,Corner_TRx
   Jl  @Kleiner1
    Je @Ende1
    Mov xAdd,-1
    Jmp @Ende1
   @Kleiner1:
   Mov xAdd,1
   @Ende1:

   Mov eax,Temp_TLy
   Cmp eax,Corner_TRy
   Jl  @Kleiner2
    Je @Ende2
    Mov yAdd,-1
    Jmp @Ende2
   @Kleiner2:
   Mov yAdd,1
   @Ende2:
  END;
  xDIFF:= abs(Temp_TLx-Corner_TRx);
  yDIFF:= abs(Temp_TLy-Corner_TRy);

  LinePosition[Position shl 1  ]:= Temp_TLx-Corner_TLx;
  LinePosition[Position shl 1+1]:= Temp_TLy-Corner_TLy;
  Inc(Position);

  If xDIFF>yDIFF then
  begin
   Rest:=-(xDIFF shr 1);
   WHILE Temp_TLx<>Corner_TRx do
   begin
    Inc(Rest    ,yDIFF);
    Inc(Temp_TLx,xADD );
    If Rest>0 then
    begin
     LinePosition[Position shl 1  ]:= Temp_TLx-Corner_TLx;
     LinePosition[Position shl 1+1]:= Temp_TLy-Corner_TLy;
     Inc(Position);
     Inc(Temp_TLy, yADD);
     Dec(Rest    ,xDIFF);
    end;
    LinePosition[Position shl 1  ]:= Temp_TLx-Corner_TLx;
    LinePosition[Position shl 1+1]:= Temp_TLy-Corner_TLy;
    Inc(Position);
   end;
  end
  else
  begin
   Rest:=-(yDIFF shr 1);
   WHILE Temp_TLy<>Corner_TRy do
   begin
    Inc(Rest    ,xDIFF);
    Inc(Temp_TLy, yADD);
    If Rest>0 then
    begin
     LinePosition[Position shl 1  ]:= Temp_TLx-Corner_TLx;
     LinePosition[Position shl 1+1]:= Temp_TLy-Corner_TLy;
     Inc(Position);
     Inc(Temp_TLx, xADD);
     Dec(Rest    ,yDIFF);
    end;
    LinePosition[Position shl 1  ]:= Temp_TLx-Corner_TLx;
    LinePosition[Position shl 1+1]:= Temp_TLy-Corner_TLy;
    Inc(Position);
   end;
  end;


 { COPY ALL LINES TO DESTINATIONSPRITE WITH AN INDEX INTO THE SOURCESPRITE }


 RealWert := Sour.BreiteMinus1 / Position;      { Used to scale sprite }
 PosRest_X:= Trunc(Frac(RealWert)*65535);
 PosGanz_X:= Trunc(RealWert) shl 1;           { Shl 1 for asm routine }

 RealWert := Sour.HoeheMinus1 / CalculateDetailLine(Corner_TLx,Corner_TLy,Corner_BLx,Corner_BLy);
 PosRest_Y:= Trunc(Frac(RealWert)*65535);
 PosGanz_Y:= Trunc(RealWert);

 ASM
  Mov eax,Corner_TLx
  Cmp eax,Corner_BLx
  Jl  @Kleiner1
   Je @Ende1
   Mov xAdd,-1
   Jmp @Ende1
  @Kleiner1:
  Mov xAdd,1
  @Ende1:

  Mov eax,Corner_TLy
  Cmp eax,Corner_BLy
  Jl  @Kleiner2
   Je @Ende2
   Mov yAdd,-1
   Jmp @Ende2
  @Kleiner2:
  Mov yAdd,1
  @Ende2:
 END;
 xDIFF:= Abs(Corner_TLx-Corner_BLx);
 yDIFF:= Abs(Corner_TLy-Corner_BLy);

 Asm
  Mov ypos,0

  Mov edi,Sour.VWOffset

  Mov eax,Sour.ByteBreite
  Mul ypos
  Add edi,eax

  Xor ecx,ecx
  @LOOPIT:

   Lea esi,LinePosition         { read actual x-add from array }
   Mov eax,ecx
   Shl eax,3
   Add esi,eax
   Mov ebx,[esi]
   Add ebx,Corner_TLx

   Mov edx,[esi+4]           { read actual y-add from array }
   Add edx,Corner_TLy


   Mov eax,Dest.Breite         { Write Pixel to destination sprite }
   Mul edx
   Add eax,ebx
   Shl eax,1
   Mov esi,Dest.VWOffset
   Add esi,eax
   Mov dx,[edi]             { Get Pixel from source sprite }
   Mov [esi],dx


   Add edi,PosGanz_X            { Inc x-position in source sprite (scaled) }
   Mov ax,PosRest_X
   Add RestCounter_X,ax
   Jnc @Jump
    Add edi,2
   @Jump:

  Inc ecx
  Cmp ecx,Position
  Jb  @LOOPIT

  Mov eax,PosGanz_Y             { Inc y-position in source sprite (scaled) }
  Add ypos,eax
  Mov ax,PosRest_Y
  Add RestCounter_Y,ax
  Jnc @JumpTo
   Inc ypos
  @JumpTo:
 End;

 If xDIFF>yDIFF then
 begin
  Rest:=-(xDIFF shr 1);
  WHILE (Corner_TLx<>Corner_BLx) do
  begin
   Inc(Rest,yDIFF);
   Inc(Corner_TLx,xADD);
   If Rest>0 then
   Asm
     Mov edi,Sour.VWOffset
     Mov eax,Sour.ByteBreite
     Mul ypos
     Add edi,eax

     Xor ecx,ecx
     @LOOPIT:

      Lea esi,LinePosition         { read actual x-add from array }
      Mov eax,ecx
      Shl eax,3
      Add esi,eax
      Mov ebx,[esi]
      Add ebx,Corner_TLx

      Mov edx,[esi+4]           { read actual y-add from array }
      Add edx,Corner_TLy


      Mov eax,Dest.Breite         { Write Pixel to destination sprite }
      Mul edx
      Add eax,ebx
      Shl eax,1
      Mov esi,Dest.VWOffset
      Add esi,eax
      Mov dx,[edi]             { Get Pixel from source sprite }
      Mov [esi],dx


      Add edi,PosGanz_X            { Inc x-position in source sprite (scaled) }
      Mov ax,PosRest_X
      Add RestCounter_X,ax
      Jnc @Jump
       Add edi,2
      @Jump:

      Inc ecx
      Cmp ecx,Position
      Jb  @LOOPIT

     Mov eax,PosGanz_Y             { Inc y-position in source sprite (scaled) }
     Add ypos,eax
     Mov ax,PosRest_Y
     Add RestCounter_Y,ax
     Jnc @JumpTo
      Inc ypos
     @JumpTo:

     Mov eax,yADD
     Add Corner_TLy,eax
     Mov eax,xDIFF
     Sub Rest,eax
   End;

   Asm
    Mov edi,Sour.VWOffset
    Mov eax,Sour.ByteBreite
    Mul ypos
    Add edi,eax

    Xor ecx,ecx
    @LOOPIT:

     Lea esi,LinePosition          { read actual x-add from array }
     Mov eax,ecx
     Shl eax,3
     Add esi,eax
     Mov ebx,[esi]
     Add ebx,Corner_TLx

     Mov edx,[esi+4]            { read actual y-add from array }
     Add edx,Corner_TLy

     Mov eax,Dest.Breite          { Write Pixel to destination sprite }
     Mul edx
     Add eax,ebx
     Shl eax,1
     Mov esi,Dest.VWOffset
     Add esi,eax
     Mov dx,[edi]              { Get Pixel from source sprite }
     Mov [esi],dx

     Add edi,PosGanz_X            { Inc x-position in source sprite (scaled) }
     Mov ax,PosRest_X
     Add RestCounter_X,ax
     Jnc @Jump
      Add edi,2
     @Jump:

    Inc ecx
    Cmp ecx,Position
    Jb  @LOOPIT

    Mov eax,PosGanz_Y              { Inc y-position in source sprite (scaled) }
    Add ypos,eax
    Mov ax,PosRest_Y
    Add RestCounter_Y,ax
    Jnc @JumpTo
     Inc ypos
    @JumpTo:
   End;

  end;
 end
 else
 begin
  Rest:=-(yDIFF shr 1);
  WHILE (Corner_TLy<>Corner_BLy) do
  begin
   Inc(Rest,xDIFF);
   Inc(Corner_TLy,yADD);
   If Rest>0 then
   Asm
     Mov edi,Sour.VWOffset
     Mov eax,Sour.ByteBreite
     Mul ypos
     Add edi,eax

     Xor ecx,ecx
     @LOOPIT:

      Lea esi,LinePosition         { read actual x-add from array }
      Mov eax,ecx
      Shl eax,3
      Add esi,eax
      Mov ebx,[esi]
      Add ebx,Corner_TLx

      Mov edx,[esi+4]           { read actual y-add from array }
      Add edx,Corner_TLy

       Mov eax,Dest.Breite         { Write Pixel to destination sprite }
       Mul edx
       Add eax,ebx
       Shl eax,1
       Mov esi,Dest.VWOffset
       Add esi,eax
       Mov dx,[edi]             { Get Pixel from source sprite }
       Mov [esi],dx

      Add edi,PosGanz_X            { Inc x-position in source sprite (scaled) }
      Mov ax,PosRest_X
      Add RestCounter_X,ax
      Jnc @Jump
       Add edi,2
      @Jump:

     Inc ecx
     Cmp ecx,Position
     Jb  @LOOPIT

     Mov eax,PosGanz_Y             { Inc y-position in source sprite (scaled) }
     Add ypos,eax
     Mov ax,PosRest_Y
     Add RestCounter_Y,ax
     Jnc @JumpTo
      Inc ypos
     @JumpTo:

     Mov eax,xADD
     Add Corner_TLx,eax
     Mov eax,yDIFF
     Sub Rest,eax
   End;

   Asm
    Mov edi,Sour.VWOffset
    Mov eax,Sour.ByteBreite
    Mul ypos
    Add edi,eax

    Xor ecx,ecx
    @LOOPIT:

     Lea esi,LinePosition          { read actual x-add from array }
     Mov eax,ecx
     Shl eax,3
     Add esi,eax
     Mov ebx,[esi]
     Add ebx,Corner_TLx

     Mov edx,[esi+4]            { read actual y-add from array }
     Add edx,Corner_TLy

      Mov eax,Dest.Breite          { Write Pixel to destination sprite }
      Mul edx
      Add eax,ebx
      Shl eax,1
      Mov esi,Dest.VWOffset
      Add esi,eax
      Mov dx,[edi]              { Get Pixel from source sprite }
      Mov [esi],dx

     Add edi,PosGanz_X            { Inc x-position in source sprite (scaled) }
     Mov ax,PosRest_X
     Add RestCounter_X,ax
     Jnc @Jump
      Add edi,2
     @Jump:

    Inc ecx
    Cmp ecx,Position
    Jb  @LOOPIT

    Mov eax,PosGanz_Y              { Inc y-position in source sprite (scaled) }
    Add ypos,eax
    Mov ax,PosRest_Y
    Add RestCounter_Y,ax
    Jnc @JumpTo
     Inc ypos
    @JumpTo:
   End;
  end;
 end;
End;




PROCEDURE Rotate_Scale_SpriteHC(Sour,Dest:VirtualWindow;x,y,Breite,Hoehe,Winkel:LongInt;Hcolor:Word);
VAR       RealWert                         : Real;
          yPos,Temp_TLx,Temp_TLy           : LongInt;
          xDIFF,yDIFF,xADD,yADD,Rest       : LongInt;
          Corner_TLx,Corner_TLy            : LongInt;
          Corner_TRx,Corner_TRy            : LongInt;
          Corner_BLx,Corner_BLy            : LongInt;
          Corner_BRx,Corner_BRy            : LongInt;
          Position,Loop                    : LongInt;
          PosGanz_X,PosGanz_Y,NewWinkel    : LongInt;
          PosRest_X,PosRest_Y              : Word;
          RestCounter_X,RestCounter_Y      : Word;

Begin


 { FIRST CALCULATE X/Y CORDS OF THE SPRITE CORNERS }


 RealWert:= Sqrt((Breite shr 1 * Breite shr 1) shl 1);

 NewWinkel:= Winkel +  45;
 If NewWinkel<  0 then NewWinkel:= NewWinkel +  (Abs(NewWinkel div 360)+1) * 360;
 If NewWinkel>360 then NewWinkel:= NewWinkel -      (NewWinkel div 360)    * 360;
 Corner_TRx:= x + Trunc( Cosin[NewWinkel] * RealWert );
 Corner_TRy:= y - Trunc( Sinus[NewWinkel] * RealWert );

 NewWinkel:= Winkel + 135;
 If NewWinkel<  0 then NewWinkel:= NewWinkel +  (Abs(NewWinkel div 360)+1) * 360;
 If NewWinkel>360 then NewWinkel:= NewWinkel -      (NewWinkel div 360)    * 360;
 Corner_TLx:= x + Trunc( Cosin[NewWinkel] * RealWert );
 Corner_TLy:= y - Trunc( Sinus[NewWinkel] * RealWert );

 NewWinkel:= Winkel + 225;
 If NewWinkel<  0 then NewWinkel:= NewWinkel +  (Abs(NewWinkel div 360)+1) * 360;
 If NewWinkel>360 then NewWinkel:= NewWinkel -      (NewWinkel div 360)    * 360;
 Corner_BLx:= x + Trunc( Cosin[NewWinkel] * RealWert );
 Corner_BLy:= y - Trunc( Sinus[NewWinkel] * RealWert );

 NewWinkel:= Winkel + 315;
 If NewWinkel<  0 then NewWinkel:= NewWinkel +  (Abs(NewWinkel div 360)+1) * 360;
 If NewWinkel>360 then NewWinkel:= NewWinkel -      (NewWinkel div 360)    * 360;
 Corner_BRx:= x + Trunc( Cosin[NewWinkel] * RealWert );
 Corner_BRy:= y - Trunc( Sinus[NewWinkel] * RealWert );


 { NOW PRECALCULATE X/Y POSITIONS IN THE FIRST LINE FOR ALL LINES (SPEED UP) }


  ASM
   Mov eax,Corner_TLx
   Mov Temp_TLx,eax
   Mov eax,Corner_TLy
   Mov Temp_TLy,eax
   Mov Position,0

   Mov eax,Temp_TLx
   Cmp eax,Corner_TRx
   Jl  @Kleiner1
    Je @Ende1
    Mov xAdd,-1
    Jmp @Ende1
   @Kleiner1:
   Mov xAdd,1
   @Ende1:

   Mov eax,Temp_TLy
   Cmp eax,Corner_TRy
   Jl  @Kleiner2
    Je @Ende2
    Mov yAdd,-1
    Jmp @Ende2
   @Kleiner2:
   Mov yAdd,1
   @Ende2:
  END;
  xDIFF:= abs(Temp_TLx-Corner_TRx);
  yDIFF:= abs(Temp_TLy-Corner_TRy);

  LinePosition[Position shl 1  ]:= Temp_TLx-Corner_TLx;
  LinePosition[Position shl 1+1]:= Temp_TLy-Corner_TLy;
  Inc(Position);

  If xDIFF>yDIFF then
  begin
   Rest:=-(xDIFF shr 1);
   WHILE Temp_TLx<>Corner_TRx do
   begin
    Inc(Rest    ,yDIFF);
    Inc(Temp_TLx,xADD );
    If Rest>0 then
    begin
     LinePosition[Position shl 1  ]:= Temp_TLx-Corner_TLx;
     LinePosition[Position shl 1+1]:= Temp_TLy-Corner_TLy;
     Inc(Position);
     Inc(Temp_TLy, yADD);
     Dec(Rest    ,xDIFF);
    end;
    LinePosition[Position shl 1  ]:= Temp_TLx-Corner_TLx;
    LinePosition[Position shl 1+1]:= Temp_TLy-Corner_TLy;
    Inc(Position);
   end;
  end
  else
  begin
   Rest:=-(yDIFF shr 1);
   WHILE Temp_TLy<>Corner_TRy do
   begin
    Inc(Rest    ,xDIFF);
    Inc(Temp_TLy, yADD);
    If Rest>0 then
    begin
     LinePosition[Position shl 1  ]:= Temp_TLx-Corner_TLx;
     LinePosition[Position shl 1+1]:= Temp_TLy-Corner_TLy;
     Inc(Position);
     Inc(Temp_TLx, xADD);
     Dec(Rest    ,yDIFF);
    end;
    LinePosition[Position shl 1  ]:= Temp_TLx-Corner_TLx;
    LinePosition[Position shl 1+1]:= Temp_TLy-Corner_TLy;
    Inc(Position);
   end;
  end;


 { COPY ALL LINES TO DESTINATIONSPRITE WITH AN INDEX INTO THE SOURCESPRITE }


 RealWert := Sour.BreiteMinus1 / Position;      { Used to scale sprite }
 PosRest_X:= Trunc(Frac(RealWert)*65535);
 PosGanz_X:= Trunc(RealWert) shl 1;            { Shl 1 for asm routine }

 RealWert := Sour.HoeheMinus1 / CalculateDetailLine(Corner_TLx,Corner_TLy,Corner_BLx,Corner_BLy);
 PosRest_Y:= Trunc(Frac(RealWert)*65535);
 PosGanz_Y:= Trunc(RealWert);

 ASM
  Mov eax,Corner_TLx
  Cmp eax,Corner_BLx
  Jl  @Kleiner1
   Je @Ende1
   Mov xAdd,-1
   Jmp @Ende1
  @Kleiner1:
  Mov xAdd,1
  @Ende1:

  Mov eax,Corner_TLy
  Cmp eax,Corner_BLy
  Jl  @Kleiner2
   Je @Ende2
   Mov yAdd,-1
   Jmp @Ende2
  @Kleiner2:
  Mov yAdd,1
  @Ende2:
 END;
 xDIFF:= Abs(Corner_TLx-Corner_BLx);
 yDIFF:= Abs(Corner_TLy-Corner_BLy);

 Asm
  Mov ypos,0

  Mov edi,Sour.VWOffset
  Mov eax,Sour.ByteBreite
  Mul ypos
  Add edi,eax

  Xor ecx,ecx
  @LOOPIT:

   Lea esi,LinePosition         { read actual x-add from array }
   Mov eax,ecx
   Shl eax,3
   Add esi,eax
   Mov ebx,[esi]
   Add ebx,Corner_TLx

   Mov edx,[esi+4]           { read actual y-add from array }
   Add edx,Corner_TLy

    Mov eax,Dest.Breite         { Write Pixel to destination sprite }
    Mul edx
    Add eax,ebx
    Shl eax,1
    Mov esi,Dest.VWOffset
    Add esi,eax
    Mov dx,[edi]             { Get Pixel from source sprite }
    Cmp dx,HColor
    Je @NOVALIDCOLOR
    Mov [esi],dx
    @NOVALIDCOLOR:

   Add edi,PosGanz_X            { Inc x-position in source sprite (scaled) }
   Mov ax,PosRest_X
   Add RestCounter_X,ax
   Jnc @Jump
    Add edi,2
   @Jump:

  Inc ecx
  Cmp ecx,Position
  Jb  @LOOPIT

  Mov eax,PosGanz_Y             { Inc y-position in source sprite (scaled) }
  Add ypos,eax
  Mov ax,PosRest_Y
  Add RestCounter_Y,ax
  Jnc @JumpTo
   Inc ypos
  @JumpTo:
 End;

 If xDIFF>yDIFF then
 begin
  Rest:=-(xDIFF shr 1);
  WHILE (Corner_TLx<>Corner_BLx) do
  begin
   Inc(Rest,yDIFF);
   Inc(Corner_TLx,xADD);
   If Rest>0 then
   Asm
     Mov edi,Sour.VWOffset
     Mov eax,Sour.ByteBreite
     Mul ypos
     Add edi,eax

     Xor ecx,ecx
     @LOOPIT:

      Lea esi,LinePosition         { read actual x-add from array }
      Mov eax,ecx
      Shl eax,3
      Add esi,eax
      Mov ebx,[esi]
      Add ebx,Corner_TLx

      Mov edx,[esi+4]           { read actual y-add from array }
      Add edx,Corner_TLy

       Mov eax,Dest.Breite         { Write Pixel to destination sprite }
       Mul edx
       Add eax,ebx
       Shl eax,1
       Mov esi,Dest.VWOffset
       Add esi,eax
       Mov dx,[edi]             { Get Pixel from source sprite }
       Cmp dx,HColor
       Je @NOVALIDCOLOR
       Mov [esi],dx
       @NOVALIDCOLOR:

      Add edi,PosGanz_X            { Inc x-position in source sprite (scaled) }
      Mov ax,PosRest_X
      Add RestCounter_X,ax
      Jnc @Jump
       Add edi,2
      @Jump:

      Inc ecx
      Cmp ecx,Position
      Jb  @LOOPIT

     Mov eax,PosGanz_Y             { Inc y-position in source sprite (scaled) }
     Add ypos,eax
     Mov ax,PosRest_Y
     Add RestCounter_Y,ax
     Jnc @JumpTo
      Inc ypos
     @JumpTo:

     Mov eax,yADD
     Add Corner_TLy,eax
     Mov eax,xDIFF
     Sub Rest,eax
   End;

   Asm
    Mov edi,Sour.VWOffset
    Mov eax,Sour.ByteBreite
    Mul ypos
    Add edi,eax

    Xor ecx,ecx
    @LOOPIT:

     Lea esi,LinePosition          { read actual x-add from array }
     Mov eax,ecx
     Shl eax,3
     Add esi,eax
     Mov ebx,[esi]
     Add ebx,Corner_TLx

     Mov edx,[esi+4]            { read actual y-add from array }
     Add edx,Corner_TLy

      Mov eax,Dest.Breite          { Write Pixel to destination sprite }
      Mul edx
      Add eax,ebx
      Shl eax,1
      Mov esi,Dest.VWOffset
      Add esi,eax
      Mov dx,[edi]              { Get Pixel from source sprite }
      Cmp dx,HColor
      Je @NOVALIDCOLOR
      Mov [esi],dx
      @NOVALIDCOLOR:

     Add edi,PosGanz_X            { Inc x-position in source sprite (scaled) }
     Mov ax,PosRest_X
     Add RestCounter_X,ax
     Jnc @Jump
      Add edi,2
     @Jump:

    Inc ecx
    Cmp ecx,Position
    Jb  @LOOPIT

    Mov eax,PosGanz_Y              { Inc y-position in source sprite (scaled) }
    Add ypos,eax
    Mov ax,PosRest_Y
    Add RestCounter_Y,ax
    Jnc @JumpTo
     Inc ypos
    @JumpTo:
   End;

  end;
 end
 else
 begin
  Rest:=-(yDIFF shr 1);
  WHILE (Corner_TLy<>Corner_BLy) do
  begin
   Inc(Rest,xDIFF);
   Inc(Corner_TLy,yADD);
   If Rest>0 then
   Asm
     Mov edi,Sour.VWOffset
     Mov eax,Sour.ByteBreite
     Mul ypos
     Add edi,eax

     Xor ecx,ecx
     @LOOPIT:

      Lea esi,LinePosition         { read actual x-add from array }
      Mov eax,ecx
      Shl eax,3
      Add esi,eax
      Mov ebx,[esi]
      Add ebx,Corner_TLx

      Mov edx,[esi+4]           { read actual y-add from array }
      Add edx,Corner_TLy

       Mov eax,Dest.Breite         { Write Pixel to destination sprite }
       Mul edx
       Add eax,ebx
       Shl eax,1
       Mov esi,Dest.VWOffset
       Add esi,eax
       Mov dx,[edi]             { Get Pixel from source sprite }
       Cmp dx,HColor
       Je @NOVALIDCOLOR
       Mov [esi],dx
       @NOVALIDCOLOR:

      Add edi,PosGanz_X            { Inc x-position in source sprite (scaled) }
      Mov ax,PosRest_X
      Add RestCounter_X,ax
      Jnc @Jump
       Add edi,2
      @Jump:

     Inc ecx
     Cmp ecx,Position
     Jb  @LOOPIT

     Mov eax,PosGanz_Y             { Inc y-position in source sprite (scaled) }
     Add ypos,eax
     Mov ax,PosRest_Y
     Add RestCounter_Y,ax
     Jnc @JumpTo
      Inc ypos
     @JumpTo:

     Mov eax,xADD
     Add Corner_TLx,eax
     Mov eax,yDIFF
     Sub Rest,eax
   End;

   Asm
    Mov edi,Sour.VWOffset
    Mov eax,Sour.ByteBreite
    Mul ypos
    Add edi,eax

    Xor ecx,ecx
    @LOOPIT:

     Lea esi,LinePosition          { read actual x-add from array }
     Mov eax,ecx
     Shl eax,3
     Add esi,eax
     Mov ebx,[esi]
     Add ebx,Corner_TLx

     Mov edx,[esi+4]            { read actual y-add from array }
     Add edx,Corner_TLy

      Mov eax,Dest.Breite          { Write Pixel to destination sprite }
      Mul edx
      Add eax,ebx
      Shl eax,1
      Mov esi,Dest.VWOffset
      Add esi,eax
      Mov dx,[edi]              { Get Pixel from source sprite }
      Cmp dx,HColor
      Je @NOVALIDCOLOR
      Mov [esi],dx
      @NOVALIDCOLOR:

     Add edi,PosGanz_X            { Inc x-position in source sprite (scaled) }
     Mov ax,PosRest_X
     Add RestCounter_X,ax
     Jnc @Jump
      Add edi,2
     @Jump:

    Inc ecx
    Cmp ecx,Position
    Jb  @LOOPIT

    Mov eax,PosGanz_Y              { Inc y-position in source sprite (scaled) }
    Add ypos,eax
    Mov ax,PosRest_Y
    Add RestCounter_Y,ax
    Jnc @JumpTo
     Inc ypos
    @JumpTo:
   End;
  end;
 end;
End;




PROCEDURE Rotate_Sprite180(Sour,Dest:VirtualWindow);
VAR       xpos,ypos : Longint;
Begin
 For xpos:= 0 to Sour.BreiteMinus1 do
 For ypos:= 0 to Sour. HoeheMinus1 do
 PutPackedpixel(Dest,xpos,ypos,GetPackedPixel(Sour,Sour.BreiteMinus1-xpos,Sour.HoeheMinus1-ypos));
End;




(******************************** INIT UNIT *********************************)


BEGIN

END.

