{$ASMMODE INTEL}
{$APPTYPE GUI}
{$MODE FPC}
{$RANGECHECKS OFF}
{$Q-}
{$S-}
{$D-}


//////////////////////////////////////////////////
// Copyright (c) 2002 by venom, VENOM Software. //
// All rights reserved.                         //
// Visit me at http://www.venomsoftware.de      //
//////////////////////////////////////////////////




UNIT VGFX_Win32;


INTERFACE




USES    Windows,Sysutils,
        VGFX,
        VGFX_Errors;



TYPE    Config                     = Record
                                      Video_Fullscreen : Boolean;
                                      Video_Device     : LongInt;
                                      Video_Breite     : LongInt;
                                      Video_Hoehe      : LongInt;
                                      Video_Bpp        : LongInt;

                                      Audio_Driver     : LongInt;
                                      Audio_Device     : LongInt;
                                      Audio_Quality    : LongInt;
                                     End;


CONST   VGFX_Win32_Version = 2.0;

CONST   ProcessSysCommands         : Boolean = False;
        WasInterrupted             : Boolean = False;
        UseSelfDefinedGDIrender    : Boolean = False;
        UseSelfDefinedICON         : Boolean = False;

        WIN_Unknown                = 0;
        WIN_Normal                 = 1;
        WIN_Saver                  = 2;
        WIN_Preview                = 3;

        m_moved                    : Boolean = False;
        m_moved_diff               : Longint = 0;

        Copyright = '(c) Copyright 2002 by venom, VENOM Software. All rights reserved.';



VAR     Window_Main_DeviceHandle   : HDC;                      // Win stuff
        Window_Paint_DeviceHandle  : HDC;
        Window_Paint_Structure     : PaintStruct;
        Window_EventMessage        : TMsg;
        Window_Class_Main          : WndClass;
        PixColor                   : ColorREF;

        ApplicationName            : PChar;
        WM_Paint_RENDER            : PROCEDURE;

        Saver_Mode                 : Byte;                     // Screen Saver
        Saver_ParentHandle         : Hwnd;
        Saver_RECT                 : Rect;

        KTaste                     : Array[0..256] of Boolean; // Input stuff
        m_l,m_r                    : Boolean;
        m_x,m_y                    : Word;










PROCEDURE GetAllMessages;

PROCEDURE HandleMinimized;

PROCEDURE Terminate;

PROCEDURE Window_RegisterClass(Klasse:Byte);

FUNCTION  Window_CreateClass(Application:PChar;Klasse:Byte): HWnd;


FUNCTION  Window_EventHandle(Window:HWnd;EventMessage,WParam,LParam:Longint) : Longint; StdCall; Export;


FUNCTION  Keypressed:Boolean;

PROCEDURE FalseKeys;
PROCEDURE FalseMouse;

PROCEDURE CheckWMCreate;

PROCEDURE Leer;

PROCEDURE CenterHWND(Window:HWnd;OptionalXAdd,OptionalYAdd:LongInt);

PROCEDURE GetSaverSettings;






IMPLEMENTATION





{------------ This function gets all messages -------------------------------}

PROCEDURE GetAllMessages;
VAR       Killed : Boolean;
Begin
 m_moved:= False;
 Killed := False;
 While PeekMessage(Window_EventMessage,0,0,0,PM_REMOVE) and not Killed do
 begin
  If Window_EventMessage.Message = WM_Quit then Killed:= True else
  begin
   TranslateMessage(Window_EventMessage);
   DispatchMessage (Window_EventMessage);
  end;
 end;
End;


{------------ This function gets all messages -------------------------------}

PROCEDURE HandleMinimized;
Begin
 If not Maximiert then
 begin
  WasInterrupted:= True;
  REPEAT GETALLMESSAGES UNTIL Maximiert or not ApplicationRunning;
  FalseKeys;
  FalseMouse;
 end else WasInterrupted:= False;
End;


{------------ This procedure exits the program ------------------------------}

PROCEDURE Terminate;
Begin
 If ApplicationRunning then
 begin
  DestroyWindow(Window_Main_Handle);
  GetAllMessages;
 end;
End;



{------------ This function registers a window class ------------------------}

PROCEDURE Window_RegisterClass(Klasse:Byte);
Begin
 CASE Klasse of

  WIN_Normal,
  WIN_Unknown,
  WIN_Saver   : begin
                 Window_Class_Main.Style        := Cs_ByteAlignWindow;
                 Window_Class_Main.lpfnWndProc  := WndProc(@Window_EventHandle);
                 Window_Class_Main.cbClsExtra   := 0;
                 Window_Class_Main.cbWndExtra   := 0;
                 Window_Class_Main.hInstance    := hInstance;
                 Window_Class_Main.hCursor      := LoadCursor(0,IDC_Arrow);
                 Window_Class_Main.hbrBackground:= GetStockObject(BLACK_BRUSH);
                 Window_Class_Main.lpszMenuName := Nil;
                 Window_Class_Main.lpszClassName:= WindowClass;

                 If UseSelfDefinedIcon
                 then Window_Class_Main.hIcon   := LoadIcon(hInstance,MAKEINTRESOURCE(125))
                 else Window_Class_Main.hIcon   := LoadIcon(        0,     IDI_Application);

                 If Window_Class_Main.hIcon = 0 then POST('INTERNAL ERROR','Loading application icon failed !'+#13+#13+'NOTE : Nevertheless you can continue with this application');
                end;

  WIN_Preview : begin
                 Window_Class_Main.Style        := CS_ParentDC;
                 Window_Class_Main.lpfnWndProc  := WndProc(@Window_EventHandle);
                 Window_Class_Main.cbClsExtra   := 0;
                 Window_Class_Main.cbWndExtra   := 0;
                 Window_Class_Main.hInstance    := hInstance;
                 Window_Class_Main.hCursor      := LoadCursor(0,IDC_Arrow);
                 Window_Class_Main.hbrBackground:= GetStockObject(BLACK_BRUSH);
                 Window_Class_Main.lpszMenuName := Nil;
                 Window_Class_Main.lpszClassName:= WindowClass;

                 If UseSelfDefinedIcon
                 then Window_Class_Main.hIcon   := LoadIcon(hInstance,  MAKEINTRESOURCE(125))
                 else Window_Class_Main.hIcon   := LoadIcon(        0,       IDI_Application);

                 If Window_Class_Main.hIcon = 0 then POST('INTERNAL ERROR','Loading application icon failed !'+#13+#13+'NOTE : Nevertheless you can continue with this application');
                end;

 END;

 If RegisterClass(Window_Class_Main) = 0 then ERRORM('WINDOWS ERROR','Register window class failed !'+#13+'An unknown error occured when calling API-Function "RegisterClass" !');
End;



{------------ This function creates a window class --------------------------}

FUNCTION Window_CreateClass(Application:PChar;Klasse:Byte) : HWnd;
VAR      WindowHandle : HWnd;
Begin
 ApplicationName:= Application;

 CASE Klasse of

  WIN_Normal,
  WIN_Unknown : WindowHandle:= CreateWindowEX(            0,WindowClass,ApplicationName,WS_SysMenu or WS_Visible or WS_Popup      , 0, 0,CW_UseDefault   ,CW_UseDefault    ,                 0, 0,hInstance,Nil);

  WIN_Saver   : WindowHandle:= CreateWindowEX(WS_EX_TopMost,WindowClass,ApplicationName,WS_SysMenu or WS_Visible or WS_Popup      , 0, 0,CW_UseDefault   ,CW_UseDefault    ,                 0, 0,hInstance,Nil);

  WIN_Preview : WindowHandle:= CreateWindowEX(            0,WindowClass,ApplicationName,WS_SysMenu or WS_Visible or WS_ChildWindow, 0, 0,Saver_RECT.Right,Saver_RECT.Bottom,Saver_ParentHandle, 0,hInstance,Nil);

 END;

 If WindowHandle = 0 then ERRORM('WINDOWS ERROR','Creating new window failed !'+#13+'An unknown error occured when calling API-Function "CreateWindowEx" !')
 else
 begin
  ShowWindow(WindowHandle,SW_ShowNormal);
  If not UpdateWindow(WindowHandle) then ERRORM('WINDOWS ERROR','Updating window failed !'+#13+'An unknown error occured when calling API-Function "UpdateWindow" !');
  Window_Main_DeviceHandle:= GetDC(WindowHandle);
  If Window_Main_DeviceHandle = 0 then ERRORM('WINDOWS ERROR','Retrieve display device context failed !'+#13+'An unknown error occured when calling API-Function "GetDC" !');
  DrawIcon(Window_Main_DeviceHandle,0,0,Window_Class_Main.hIcon);
 end;

 Window_CreateClass:= WindowHandle;
End;



{------------ This function handles the events ------------------------------}

FUNCTION Window_EventHandle(Window:HWnd;EventMessage,WParam,LParam:Longint) : Longint; StdCall; Export;
Begin
 Window_EventHandle:= 0;
 KTaste[256]:= False;

  CASE EventMessage of
   WM_Activate  : If (WParam shr 16)<>0 then Maximiert:= False else Maximiert:= True;

   WM_Create    : ApplicationRunning:= True;

   WM_Destroy   : begin
                   ApplicationRunning:= False;
                   If ReleaseDC(Window_Main_Handle,Window_Main_DeviceHandle) = 0 then ERRORM('WINDOWS ERROR','Releasing device context failed !'+#13+'An unknown error occured when calling API-Function "ReleaseDC" !');
                   Window_Main_DeviceHandle:= 0;
                   PostQuitMessage(0);
                  end;

   WM_Keyup     : KTaste[WParam]:= False;
   WM_Keydown   : begin
                   KTaste[WParam]:= True;
                   KTaste[256   ]:= True;
                  end;
   WM_SYSKeydown: begin
                   KTaste[256]:= True;
                   Window_EventHandle:= DefWindowProc(Window,EventMessage, WParam, LParam);
                  end;

   WM_Mousemove : begin
                   m_moved:= True;
                   m_moved_diff:= Abs(m_x - (LParam and $FFFF)) + Abs(m_y - (LParam shr 16));
                   m_y:= LParam shr 16;
                   m_x:= LParam and $FFFF;
                   If WParam= MK_LBUTTON then m_l:= true;
                   If WParam= MK_RBUTTON then m_r:= true;
                  end;

   WM_LBUTTONDOWN : m_l:= true;
   WM_RBUTTONDOWN : m_r:= true;
   WM_LBUTTONUP   : m_l:= false;
   WM_RBUTTONUP   : m_r:= false;

   WM_Paint       : begin
                     If UseSelfDefinedGDIrender then
                     begin
                      If not VGFXGraphLoaded
                      then WM_Paint_RENDER()
                      else Window_EventHandle:= DefWindowProc(Window,EventMessage, WParam, LParam);
                     end
                     else Window_EventHandle:= DefWindowProc(Window,EventMessage, WParam, LParam);
                    end;

   WM_SYSCOMMAND  : If not ProcessSysCommands
                    then Window_EventHandle:= DefWindowProc(Window,EventMessage, WParam, LParam)
                    else
                    CASE WParam of
                     SC_SCREENSAVE   : Window_EventHandle:= 0;
                     SC_MONITORPOWER : Window_EventHandle:= 0;
                     Else Window_EventHandle:= DefWindowProc(Window,EventMessage, WParam, LParam);
                    END;

   Else Window_EventHandle:= DefWindowProc(Window,EventMessage, WParam, LParam);
  END;
End;



{------------ This function checks if a key is pressed ----------------------}

FUNCTION Keypressed:Boolean;
VAR      ThaLoop : Word;
Begin
 Keypressed:= KTaste[256];
 ThaLoop:= 0;
 While (ThaLoop<256) and not Keypressed do
 begin
  If KTaste[ThaLoop] then Keypressed:= True;
  Inc(ThaLoop);
 end;
End;


{------------ This sets all keys to "up" ------------------------------------}

PROCEDURE FalseKeys;
VAR       ThaLoop : Word;
Begin
 For ThaLoop:= 0 to 256 do KTaste[ThaLoop]:= False;
End;


PROCEDURE FalseMouse;
Begin
 m_l:= False;
 m_r:= False;
End;



{------------ This function checks if the the new window has started --------}

PROCEDURE CheckWMCreate;
VAR       CheckVar : Byte;
Begin
 CheckVar:= 0;
 REPEAT  GETALLMESSAGES; Inc(CheckVar); UNTIL ApplicationRunning or (CheckVar=255);
 If CheckVar=255 then ERRORM('WINDOWS ERROR','Creating new window failed !'+#13+'The "WM_Create" message was not received after creating a new window !');
 WAITMS(500);
End;



{------------ This function is only a dummy for not set WM_Paint_RENDER -----}

PROCEDURE Leer;
Begin

End;


{------------ This function centers a window in his parent window -----------}

PROCEDURE CenterHWND(Window:HWnd;OptionalXAdd,OptionalYAdd:LongInt);
VAR       Parent_RECT    : Rect;
          Parent_HWND    : HWnd;
          Parent_Breite  : LongInt;
          Parent_Hoehe   : LongInt;
          Window_RECT    : Rect;
          Window_Breite  : LongInt;
          Window_Hoehe   : LongInt;
          Window_Xnew    : LongInt;
          Window_Ynew    : LongInt;
          Desktop_Breite : LongInt;
          Desktop_Hoehe  : LongInt;
Begin
 Desktop_Breite:= GetSystemMetrics(SM_CXSCREEN);  // Get Desktop Width/Height
 Desktop_Hoehe := GetSystemMetrics(SM_CYSCREEN);

 Parent_HWND:= GetWindowLong(Window,GWL_HWNDParent);       // Get Parent HWnd

 If IsWindow(Parent_HWND) then
 begin
  GetWindowRect(Parent_HWND,@Parent_RECT);
  Parent_Breite:= Parent_RECT.Right  - Parent_RECT.Left;
  Parent_Hoehe := Parent_RECT.Bottom - Parent_RECT.Top;
 end
 else
 begin
  Parent_Breite:= 0;        // Center on desktop if parent is no valid window
  Parent_Hoehe := 0;
 end;

 GetWindowRect(Window,@Window_RECT);
 Window_Breite:= Window_RECT.Right  - Window_RECT.Left;
 Window_Hoehe := Window_RECT.Bottom - Window_RECT.Top;

 Window_Xnew:= (Parent_Breite - Window_Breite) shr 1 + Parent_RECT.Left;
 Window_Ynew:= (Parent_Hoehe  - Window_Hoehe ) shr 1 + Parent_RECT.Top;

 Window_Xnew:= Window_Xnew + OptionalXAdd;
 Window_Ynew:= Window_Ynew + OptionalYAdd;

 If (Window_Xnew<0) or (Window_Ynew<0) or (Window_Xnew+Window_Breite>Desktop_Breite) or (Window_Ynew+Window_Hoehe>Desktop_Hoehe) then
 begin
  Window_Xnew:= (Desktop_Breite - Window_Breite) shr 1;
  Window_Ynew:= (Desktop_Hoehe  - Window_Hoehe ) shr 1;
 end;

 MoveWindow(Window, Window_Xnew, Window_Ynew, Window_Breite, Window_Hoehe, True);
End;



{------------ This function gets Saver mode and handle from command line ----}

PROCEDURE GetSaverSettings;
VAR       CString : String;
Begin
 Saver_Mode        := WIN_Unknown;
 Saver_ParentHandle:= 0;

 Saver_RECT.Top    := 0;
 Saver_RECT.Left   := 0;
 Saver_RECT.Right  := CW_UseDefault;
 Saver_RECT.Bottom := CW_UseDefault;

 If ParamCount > 0 then CString:= UpCase(ParamStr(1)) else Saver_Mode:= WIN_Normal;
 If ParamCount > 1 then
 begin
  Val(ParamStr(2),Saver_ParentHandle);
  If not GetClientRect(Saver_ParentHandle,@Saver_RECT) then ERRORM('WINDOWS ERROR','An unknown error occured when calling API-Function "GetClientRect" !');
 end;

 If (Copy(CString,1,2) = '/C') or                  // Config mode
    (Copy(CString,1,2) = '-C') or
    (Copy(CString,1,1) =  'C') then Saver_Mode:= WIN_Normal;

 If (Copy(CString,1,2) = '/P') or                  // Preview window mode
    (Copy(CString,1,2) = '-P') or
    (Copy(CString,1,1) =  'P') or
    (Copy(CString,1,2) = '/L') or
    (Copy(CString,1,2) = '-L') or
    (Copy(CString,1,1) =  'L') then Saver_Mode:= WIN_Preview;

 If (Copy(CString,1,2) = '/W') or                  // Windowed or Fullscreen
    (Copy(CString,1,2) = '-W') or
    (Copy(CString,1,1) =  'W') or
    (Copy(CString,1,2) = '/S') or
    (Copy(CString,1,2) = '-S') or
    (Copy(CString,1,1) =  'S') then Saver_Mode:= WIN_Saver;

 If Saver_Mode = WIN_Saver then ProcessSysCommands:= True;
End;






(******************************** INIT UNIT *********************************)


BEGIN
 WM_Paint_RENDER:= @Leer;

 AfterPOSTproc:= @GetAllmessages;

 FalseKeys;
END.

