{$ASMMODE INTEL}
{$APPTYPE GUI}
{$MODE FPC}
{$RANGECHECKS OFF}
{$Q-}
{$S-}
{$D-}

PROGRAM VGFX_Demo;



USES    Windows,
        VGFX,
        VGFX_2D,
        VGFX_Sprites,
        VGFX_Text,
        VGFX_win32,
        VGFX_Files,
        VGFX_Errors,
        BigFile2,
        SysUtils,
        KeyBoard;




CONST   ApplicationID        : PChar = 'VGFXdemo';   // <== Your application title shown in the task bar...etc..


        Width                : Longint = 800;         // Just to hold our resolution (Don't use a lower resolution IN THIS DEMO
        Height               : Longint = 600;         // cause we rotate a sprite on the screen which is not clipped !!!)


VAR     Sprite01             : VirtualWindow;        // Our image variables, use them for sprites and backgrounds...
        BackGround           : VirtualWindow;
        results              : VirtualWindow;

        Rotation             : Longint;              // Holds our actual sprite rotation...see below
        Scaling              : Single;               // Holds our scaling value
        R,G,B                : Byte;










(*============================ HAUPTPROGRAMM ===============================*)


var key:TKeyEvent;

BEGIN

 Window_RegisterClass(WIN_Normal);  // Always register your windows class with the WIN_Normal style, I defined also other styles for screen savers etc.. but I think that would be to complex for the first time...

 Window_Main_Handle:= Window_CreateClass(ApplicationID,WIN_Normal);   // Here you create your registered window class, change ApplicationID at the top to use your own application title...

 CheckWMCreate;                     // Here we check again ob the window finally exists... this code is not really important cause we also check for errors during window registration etc...


 Init_Graph(Width,Height);          // Here you can choose the graphic mode you want...there is no limit...theoretical...but watch out for your resolution supported by your monitor
                                    // It will always be a 16 Bit mode


 Load_Fonts('Fonts.fnt');           // Loads the standard fonts...they are not really beautifull...I used sprites with fonts if I wanted to show beatifull text. Use the VGFX_text routines only after loading this font file...

 Load_Pcx('Image.pcx','',Sprite01); // Here we load Image.pcx in our Sprite01. The second parameter is set to '' cause we don't want to load the pcx from a bigfile
                                    // Note that Sprite01 has to be an empty (not init) VirtualWindow cause Load_pcx and Load_Sprite allocate new memory for the image before they load it !!

 Init_VW(Results,Width,Height,True); // Here we init a sprite used to keep our final drawing result

 Init_VW(BackGround,Width,Height,True);    // Here we init BackGround with our resolution. The last parameter is set to true cause we want the new memory space to be set zo zero (black :)


 ScaleSprite(Sprite01,BackGround);    // Here we scale our image in Sprite01 to the size of BackGround which is also our actual resolution. The result is stored in BackGround and will be used as background to fill the whole screen

 Settextsize(1);
 Outtextxy(BackGround,10,10,31,63,31,'Here we put some text on the screen');  // Okay, here we draw some text on our BackGround at position(10,10) with color (r=31,g=63,b=31)

 PutPixel(Background,Width-50,20,31,63,31); // Draw a white pixel at the top right

 GetPixel(Background,Width-50,20,R,G,B); // Read back the pixel RGB values

 IF R+G+B = 125 then PutPixel(Background,Width-49,20,31,0,0); // If the value we just read back is correct, draw a red pixel besides the white one

 CursorVisible(True);               // We want to see our cursor, otherwise set to false

 REPEAT    // Our main loop

                                                        // So we can always write something on the screen without "destroying" our background...

   Flip_VW(BackGround.VWOffset,results.VWOffset);      // Here we refresh our result image which we want finally show on the screen
   Flip_VW(BackGround.VWOffset,results.VWOffset);      // Here we refresh our result image which we want finally show on the screen

   Rotation:= Gettickcount div 10;                          // Gettickcount returns you the time in ms your application is running
   Scaling := 10+Abs(Sin((Gettickcount / 300000) * 360)*400);

                                                                       // Here we rotate a sprite in the middle of the screen and also scale it...
   Rotate_Scale_SpriteHC(Sprite01,results,results.BreiteDiv2,results.HoeheDiv2,Round(Scaling),Round(Scaling),Rotation,0);


   PutAlphaClippedHCSprite(results,Sprite01,results.BreiteDiv2-Sprite01.BreiteDiv2+Round(Sin((Gettickcount / 200000) * 360)*200),results.HoeheDiv2-Sprite01.HoeheDiv2+Round(Cos((Gettickcount / 200000) * 360)*200),0);

   OutTextXy(results,550,Height-30,255,255,255,'Our mouse x position : '+Longintstr( m_x ));  // Here we convert our mouse x-position to a string and show it on the screen
   OutTextXy(results,550,Height-10,255,255,255,'Our mouse y position : '+Longintstr( m_y ));  // Same for the y-position...


   Flip_DD(Results.VWOffset);        // Now let us flip our result to the screen, always flip VirtualWindows only if they have the same size like the actual resolution (here 800x600)


   GETALLMESSAGES;                      // Here we get ALL windows messages, you need this call in every loop you want to get windows messages (keyboard, mouse, termination, maximisation, etc....)

   HANDLEMINIMIZED;                     // Also an important function call you should use in every main loop. This function checks if your window was minimzed and then stops your application so that it doesn't use any CPU performance


 UNTIL not ApplicationRunning or KTaste[27] or m_l;   // We exit the main loop if our program was terminated (also by Alt-F4) etc... or if the user hits the Enter key (KTaste[13]) or if the left mouse button was pressed (m_l)
                                                      // KTaste[27] would be the ESC key, KTaste[8] the backspace...etc...
                                                      // KTaste[X] is true if it's pressed and false if it's not...
                                                      // Use m_x and m_y to get the actual mouse x,y coords...







 Kill_VW(BackGround);                 // Don't forget to clean memory before exit ! So we free our image data from the memory
 Kill_VW(Sprite01);
 Kill_VW(results);


 Kill_Graph;                        // No we close our grahic mode and reset the old desktop resolution

 CheckMemory;                       // You can use this function to control if you have freed all memory correctly without any memory leaks... This controls only memory used by virtualwindows and by the memory allocation functions of VGFX (allokptrspeiche
                                    // r...etc...)

 TERMINATE;                         // Here we say windows "Good bye..."

END.
